'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _utils = require('../utils');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _defaults(obj, defaults) { var keys = Object.getOwnPropertyNames(defaults); for (var i = 0; i < keys.length; i++) { var key = keys[i]; var value = Object.getOwnPropertyDescriptor(defaults, key); if (value && value.configurable && obj[key] === undefined) { Object.defineProperty(obj, key, value); } } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : _defaults(subClass, superClass); }

var Header = function (_React$PureComponent) {
  _inherits(Header, _React$PureComponent);

  function Header() {
    var _temp, _this, _ret;

    _classCallCheck(this, Header);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _React$PureComponent.call.apply(_React$PureComponent, [this].concat(args))), _this), _this.addPrefix = function (name) {
      return (0, _utils.prefix)(_this.props.classPrefix)(name);
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  Header.prototype.getTimeFormat = function getTimeFormat() {
    var format = this.props.format;

    var timeFormat = [];

    if (!format) {
      return '';
    }

    if (/(H|h)/.test(format)) {
      timeFormat.push('HH');
    }
    if (/m/.test(format)) {
      timeFormat.push('mm');
    }
    if (/s/.test(format)) {
      timeFormat.push('ss');
    }

    return timeFormat.join(':');
  };

  Header.prototype.getDateFormat = function getDateFormat() {
    var _props = this.props,
        showDate = _props.showDate,
        showMonth = _props.showMonth;


    if (showDate) {
      return 'YYYY-MM-DD';
    } else if (showMonth) {
      return 'YYYY-MM';
    }

    return 'YYYY';
  };

  Header.prototype.render = function render() {
    var _classNames, _classNames2, _classNames3, _classNames4, _classNames5;

    var _props2 = this.props,
        date = _props2.date,
        onMoveForword = _props2.onMoveForword,
        onMoveBackward = _props2.onMoveBackward,
        onToggleMonthDropdown = _props2.onToggleMonthDropdown,
        onToggleTimeDropdown = _props2.onToggleTimeDropdown,
        showTime = _props2.showTime,
        showDate = _props2.showDate,
        showMonth = _props2.showMonth,
        classPrefix = _props2.classPrefix,
        className = _props2.className,
        disabledDate = _props2.disabledDate,
        disabledTime = _props2.disabledTime,
        disabledBackward = _props2.disabledBackward,
        disabledForword = _props2.disabledForword,
        rest = _objectWithoutProperties(_props2, ['date', 'onMoveForword', 'onMoveBackward', 'onToggleMonthDropdown', 'onToggleTimeDropdown', 'showTime', 'showDate', 'showMonth', 'classPrefix', 'className', 'disabledDate', 'disabledTime', 'disabledBackward', 'disabledForword']);

    var dateTitleClasses = (0, _classnames2.default)(this.addPrefix('title'), this.addPrefix('title-date'), (_classNames = {}, _classNames[this.addPrefix('error')] = disabledDate && disabledDate(date), _classNames));

    var timeTitleClasses = (0, _classnames2.default)(this.addPrefix('title'), this.addPrefix('title-time'), (_classNames2 = {}, _classNames2[this.addPrefix('error')] = disabledTime && disabledTime(date), _classNames2));

    var backwardClass = (0, _classnames2.default)(this.addPrefix('backward'), (_classNames3 = {}, _classNames3[this.addPrefix('btn-disabled')] = disabledBackward, _classNames3));

    var forwardClass = (0, _classnames2.default)(this.addPrefix('forward'), (_classNames4 = {}, _classNames4[this.addPrefix('btn-disabled')] = disabledForword, _classNames4));

    var monthToolbar = React.createElement(
      'div',
      { className: this.addPrefix('month-toolbar') },
      React.createElement('i', {
        className: backwardClass,
        role: 'button',
        tabIndex: '-1',
        onClick: disabledBackward ? undefined : onMoveBackward
      }),
      React.createElement(
        'span',
        {
          role: 'button',
          tabIndex: '-1',
          className: dateTitleClasses,
          onClick: onToggleMonthDropdown
        },
        date && date.format(this.getDateFormat())
      ),
      React.createElement('i', {
        className: forwardClass,
        role: 'button',
        tabIndex: '-1',
        onClick: disabledForword ? undefined : onMoveForword
      })
    );

    var hasMonth = showDate || showMonth;
    var classes = (0, _classnames2.default)(classPrefix, className, (_classNames5 = {}, _classNames5[this.addPrefix('has-month')] = hasMonth, _classNames5[this.addPrefix('has-time')] = showTime, _classNames5));
    var unhandled = (0, _utils.getUnhandledProps)(Header, rest);

    return React.createElement(
      'div',
      _extends({}, unhandled, { className: classes }),
      hasMonth && monthToolbar,
      showTime && React.createElement(
        'div',
        { className: this.addPrefix('time-toolbar') },
        React.createElement(
          'span',
          {
            role: 'button',
            tabIndex: '-1',
            className: timeTitleClasses,
            onClick: onToggleTimeDropdown
          },
          date && date.format(this.getTimeFormat())
        )
      )
    );
  };

  return Header;
}(React.PureComponent);

Header.defaultProps = {
  date: (0, _moment2.default)()
};
Header.handledProps = ['className', 'classPrefix', 'date', 'disabledBackward', 'disabledDate', 'disabledForword', 'disabledTime', 'format', 'onMoveBackward', 'onMoveForword', 'onToggleMonthDropdown', 'onToggleTimeDropdown', 'showDate', 'showMonth', 'showTime'];
Header.propTypes = {
  date: function date() {
    return (typeof moment$Moment === 'function' ? _propTypes2.default.instanceOf(moment$Moment).isRequired : _propTypes2.default.any.isRequired).apply(this, arguments);
  },
  onMoveForword: _propTypes2.default.func,
  onMoveBackward: _propTypes2.default.func,
  onToggleMonthDropdown: _propTypes2.default.func,
  onToggleTimeDropdown: _propTypes2.default.func,
  showMonth: _propTypes2.default.bool,
  showDate: _propTypes2.default.bool,
  showTime: _propTypes2.default.bool,
  format: _propTypes2.default.string,
  disabledDate: _propTypes2.default.func,
  disabledTime: _propTypes2.default.func,
  classPrefix: _propTypes2.default.string,
  className: _propTypes2.default.string,
  disabledBackward: _propTypes2.default.bool,
  disabledForword: _propTypes2.default.bool
};


var enhance = (0, _utils.defaultProps)({
  classPrefix: 'calendar-header'
});
exports.default = enhance(Header);