'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _utils = require('../utils');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _defaults(obj, defaults) { var keys = Object.getOwnPropertyNames(defaults); for (var i = 0; i < keys.length; i++) { var key = keys[i]; var value = Object.getOwnPropertyDescriptor(defaults, key); if (value && value.configurable && obj[key] === undefined) { Object.defineProperty(obj, key, value); } } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : _defaults(subClass, superClass); }

var TableRow = function (_React$PureComponent) {
  _inherits(TableRow, _React$PureComponent);

  function TableRow() {
    var _temp, _this, _ret;

    _classCallCheck(this, TableRow);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _React$PureComponent.call.apply(_React$PureComponent, [this].concat(args))), _this), _this.addPrefix = function (name) {
      return (0, _utils.prefix)(_this.props.classPrefix)(name);
    }, _this.handleSelect = function (date, disabled) {
      var onSelect = _this.props.onSelect;

      if (disabled) {
        return;
      }
      onSelect && onSelect(date);
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  TableRow.prototype.renderDays = function renderDays() {
    var _props = this.props,
        weekendDate = _props.weekendDate,
        disabledDate = _props.disabledDate,
        inSameMonth = _props.inSameMonth,
        selected = _props.selected,
        onSelect = _props.onSelect;


    var days = [];
    for (var i = 0; i < 7; i += 1) {
      var _classNames;

      var thisDate = (0, _moment2.default)(weekendDate).add(i, 'd');
      var disabled = disabledDate && disabledDate(thisDate.clone());
      var isToday = thisDate.isSame((0, _moment2.default)(), 'date');
      var classes = (0, _classnames2.default)(this.addPrefix('cell'), (_classNames = {}, _classNames[this.addPrefix('cell-un-same-month')] = !(inSameMonth && inSameMonth(thisDate)), _classNames[this.addPrefix('cell-is-today')] = isToday, _classNames[this.addPrefix('cell-selected')] = thisDate.isSame(selected, 'date'), _classNames[this.addPrefix('cell-disabled')] = disabled, _classNames));

      days.push(React.createElement(
        'div',
        {
          className: classes,
          role: 'menu',
          tabIndex: '-1',
          title: isToday ? 'Today' : '',
          onClick: this.handleSelect.bind(this, thisDate, disabled),
          key: i
        },
        React.createElement(
          'span',
          { className: this.addPrefix('cell-content') },
          thisDate.date()
        )
      ));
    }
    return days;
  };

  TableRow.prototype.render = function render() {
    var _props2 = this.props,
        className = _props2.className,
        rest = _objectWithoutProperties(_props2, ['className']);

    var classes = (0, _classnames2.default)(this.addPrefix('row'), className);
    var unhandled = (0, _utils.getUnhandledProps)(TableRow, rest);

    return React.createElement(
      'div',
      _extends({}, unhandled, { className: classes }),
      this.renderDays()
    );
  };

  return TableRow;
}(React.PureComponent);

TableRow.defaultProps = {
  selected: (0, _moment2.default)()
};
TableRow.handledProps = ['className', 'classPrefix', 'disabledDate', 'inSameMonth', 'onSelect', 'selected', 'weekendDate'];
TableRow.propTypes = {
  weekendDate: function weekendDate() {
    return (typeof moment$Moment === 'function' ? _propTypes2.default.instanceOf(moment$Moment) : _propTypes2.default.any).apply(this, arguments);
  },
  selected: function selected() {
    return (typeof moment$Moment === 'function' ? _propTypes2.default.instanceOf(moment$Moment) : _propTypes2.default.any).apply(this, arguments);
  },
  onSelect: _propTypes2.default.func,
  disabledDate: _propTypes2.default.func,
  inSameMonth: _propTypes2.default.func,
  className: _propTypes2.default.string,
  classPrefix: _propTypes2.default.string
};


var enhance = (0, _utils.defaultProps)({
  classPrefix: 'calendar-table'
});

exports.default = enhance(TableRow);