'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _utils = require('../utils');

var _Table = require('./Table');

var _Table2 = _interopRequireDefault(_Table);

var _getMonthView = require('../utils/getMonthView');

var _getMonthView2 = _interopRequireDefault(_getMonthView);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _defaults(obj, defaults) { var keys = Object.getOwnPropertyNames(defaults); for (var i = 0; i < keys.length; i++) { var key = keys[i]; var value = Object.getOwnPropertyDescriptor(defaults, key); if (value && value.configurable && obj[key] === undefined) { Object.defineProperty(obj, key, value); } } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : _defaults(subClass, superClass); }

// is two date in the same month
var inSameMonth = function inSameMonth(dateA, dateB) {
  return dateA.month() === dateB.month();
};
var getThisMonthDate = function getThisMonthDate(date) {
  return date.clone().date(1);
};

var View = function (_React$PureComponent) {
  _inherits(View, _React$PureComponent);

  function View() {
    var _temp, _this, _ret;

    _classCallCheck(this, View);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _React$PureComponent.call.apply(_React$PureComponent, [this].concat(args))), _this), _this.inSameThisMonthDate = function (date) {
      var thisMonthDate = getThisMonthDate(_this.props.activeDate);
      return inSameMonth(date, thisMonthDate);
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  View.prototype.render = function render() {
    var _props = this.props,
        activeDate = _props.activeDate,
        onSelect = _props.onSelect,
        disabledDate = _props.disabledDate,
        className = _props.className,
        classPrefix = _props.classPrefix,
        isoWeek = _props.isoWeek,
        rest = _objectWithoutProperties(_props, ['activeDate', 'onSelect', 'disabledDate', 'className', 'classPrefix', 'isoWeek']);

    var thisMonthDate = getThisMonthDate(activeDate);
    var classes = (0, _classnames2.default)(classPrefix, className);

    return React.createElement(
      'div',
      _extends({}, rest, { className: classes }),
      React.createElement(_Table2.default, {
        rows: (0, _getMonthView2.default)(thisMonthDate, isoWeek),
        isoWeek: isoWeek,
        selected: activeDate,
        onSelect: onSelect,
        inSameMonth: this.inSameThisMonthDate,
        disabledDate: disabledDate
      })
    );
  };

  return View;
}(React.PureComponent);

View.defaultProps = {
  activeDate: (0, _moment2.default)()
};
View.handledProps = ['activeDate', 'className', 'classPrefix', 'disabledDate', 'isoWeek', 'onSelect'];
View.propTypes = {
  activeDate: function activeDate() {
    return (typeof moment$Moment === 'function' ? _propTypes2.default.instanceOf(moment$Moment).isRequired : _propTypes2.default.any.isRequired).apply(this, arguments);
  },
  onSelect: _propTypes2.default.func,
  disabledDate: _propTypes2.default.func,
  isoWeek: _propTypes2.default.bool,
  className: _propTypes2.default.string,
  classPrefix: _propTypes2.default.string
};


var enhance = (0, _utils.defaultProps)({
  classPrefix: 'calendar-view'
});

exports.default = enhance(View);