'use strict';

exports.__esModule = true;

var _pick2 = require('lodash/pick');

var _pick3 = _interopRequireDefault(_pick2);

var _kebabCase2 = require('lodash/kebabCase');

var _kebabCase3 = _interopRequireDefault(_kebabCase2);

var _isUndefined2 = require('lodash/isUndefined');

var _isUndefined3 = _interopRequireDefault(_isUndefined2);

var _get2 = require('lodash/get');

var _get3 = _interopRequireDefault(_get2);

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _rsuiteIntl = require('rsuite-intl');

var _OverlayTrigger = require('rsuite-utils/lib/Overlay/OverlayTrigger');

var _OverlayTrigger2 = _interopRequireDefault(_OverlayTrigger);

var _Picker = require('rsuite-utils/lib/Picker');

var _utils = require('rsuite-utils/lib/utils');

var _utils2 = require('../utils');

var _stringToObject2 = require('../utils/stringToObject');

var _stringToObject3 = _interopRequireDefault(_stringToObject2);

var _DropdownMenu = require('./DropdownMenu');

var _DropdownMenu2 = _interopRequireDefault(_DropdownMenu);

var _PickerToggle = require('../_picker/PickerToggle');

var _PickerToggle2 = _interopRequireDefault(_PickerToggle);

var _getToggleWrapperClassName = require('../_picker/getToggleWrapperClassName');

var _getToggleWrapperClassName2 = _interopRequireDefault(_getToggleWrapperClassName);

var _TypeDefinition = require('../utils/TypeDefinition');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defaults(obj, defaults) { var keys = Object.getOwnPropertyNames(defaults); for (var i = 0; i < keys.length; i++) { var key = keys[i]; var value = Object.getOwnPropertyDescriptor(defaults, key); if (value && value.configurable && obj[key] === undefined) { Object.defineProperty(obj, key, value); } } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : _defaults(subClass, superClass); }

var Dropdown = function (_React$Component) {
  _inherits(Dropdown, _React$Component);

  function Dropdown(props) {
    _classCallCheck(this, Dropdown);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _this.handleSelect = function (node, activePaths, isLeafNode, event) {
      var _this$props = _this.props,
          onChange = _this$props.onChange,
          onSelect = _this$props.onSelect,
          valueKey = _this$props.valueKey;

      var prevValue = _this.getValue();
      var value = node[valueKey];
      onSelect && onSelect(node, activePaths, event);

      _this.setState({
        selectNode: node
      });

      /**
       * 只有在叶子节点的时候才当做是可以选择的值
       * 一个节点的 children 为 null 或者 undefined 的是就是叶子节点
       */
      if (isLeafNode) {
        _this.closeDropdown();
        _this.setState({ value: value });
        if (!(0, _utils.shallowEqual)(value, prevValue)) {
          onChange && onChange(value, event);
        }

        if ((0, _isUndefined3.default)(_this.props.value)) {
          _this.setState({ activePaths: activePaths });
        }
      }
    };

    _this.trigger = null;

    _this.bindTriggerRef = function (ref) {
      _this.trigger = ref;
    };

    _this.menuContainer = null;

    _this.bindMenuContainerRef = function (ref) {
      _this.menuContainer = ref;
    };

    _this.container = null;

    _this.bindContainerRef = function (ref) {
      _this.container = ref;
    };

    _this.closeDropdown = function () {
      if (_this.trigger) {
        _this.trigger.hide();
      }
    };

    _this.handleClean = function (event) {
      var _this$props2 = _this.props,
          disabled = _this$props2.disabled,
          onChange = _this$props2.onChange;

      if (disabled) {
        return;
      }
      var nextState = {
        value: null,
        activePaths: []
      };
      _this.setState(nextState, function () {
        onChange && onChange(null, event);
      });
    };

    _this.handleEntered = function () {
      var onOpen = _this.props.onOpen;

      _this.updateStateForCascade();
      onOpen && onOpen();
    };

    _this.handleExited = function () {
      var onClose = _this.props.onClose;

      onClose && onClose();
    };

    _this.addPrefix = function (name) {
      return (0, _utils2.prefix)(_this.props.classPrefix)(name);
    };

    _this.state = {
      selectNode: null,
      value: props.defaultValue,
      /**
       * 选中值的路径
       */
      activePaths: [],
      /**
       * 用于展示面板的数据列表，是一个二维的数组
       * 是通过 data 树结构转换成的二维的数组，其中只包含页面上展示的数据
       */
      items: []
    };
    return _this;
  }

  Dropdown.prototype.componentWillMount = function componentWillMount() {
    this.updateStateForCascade();
  };

  Dropdown.prototype.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
    var _this2 = this;

    var value = nextProps.value,
        data = nextProps.data,
        valueKey = nextProps.valueKey;


    if (!(0, _utils.shallowEqualArray)(data, this.props.data)) {
      /**
       * 如果是异步加载更新了 data,
       * 首先获取到被点击节点的值 `selectNodeValue`， 然后再拿到新增后的 `newChildren`,
       * 把这个两个数据通过交给 updateStateForCascade 处理。
       */
      var selectNodeValue = (0, _get3.default)(this.state, ['selectNode', valueKey]);
      var newChildren = (0, _get3.default)((0, _utils.findNodeOfTree)(data, function (item) {
        return (0, _utils.shallowEqual)(item[valueKey], selectNodeValue);
      }), 'children') || [];

      this.updateStateForCascade(nextProps, selectNodeValue, newChildren.map(function (item) {
        return _this2.stringToObject(item);
      }));
    } else if (!(0, _utils.shallowEqual)(value, this.props.value)) {
      this.updateStateForCascade(nextProps);
    }
  };

  Dropdown.prototype.getValue = function getValue(nextProps) {
    var _ref = nextProps || this.props,
        value = _ref.value;

    return (0, _isUndefined3.default)(value) ? this.state.value : value;
  };

  /**
   * 在 data 对象中的数据类型是字符串比如: ['foo']
   * 通过这个行数可以把值转换成 [{name:'foo':value:'foo'}]
   */
  Dropdown.prototype.stringToObject = function stringToObject(value) {
    var _props = this.props,
        labelKey = _props.labelKey,
        valueKey = _props.valueKey;

    return (0, _stringToObject3.default)(value, labelKey, valueKey);
  };

  Dropdown.prototype.updateStateForCascade = function updateStateForCascade(nextProps, selectNodeValue, newChildren) {
    var _this3 = this;

    var _ref2 = nextProps || this.props,
        data = _ref2.data,
        valueKey = _ref2.valueKey,
        childrenKey = _ref2.childrenKey;

    var activeItemValue = selectNodeValue || this.getValue(nextProps);
    var nextItems = [];
    var nextPathItems = [];
    var findNode = function findNode(items) {
      var _loop = function _loop(i) {
        items[i] = _this3.stringToObject(items[i]);
        items[i].active = false;
        var children = items[i][childrenKey];

        if ((0, _utils.shallowEqual)(items[i][valueKey], activeItemValue)) {
          return {
            v: {
              items: items,
              active: items[i]
            }
          };
        } else if (children) {
          var v = findNode(children);
          if (v) {
            nextItems.push(children.map(function (item) {
              return _extends({}, _this3.stringToObject(item), {
                parent: items[i]
              });
            }));
            nextPathItems.push(v.active);
            return {
              v: {
                items: items,
                active: items[i]
              }
            };
          }
        }
      };

      for (var i = 0; i < items.length; i += 1) {
        var _ret = _loop(i);

        if ((typeof _ret === 'undefined' ? 'undefined' : _typeof(_ret)) === "object") return _ret.v;
      }
      return null;
    };

    var activeItem = findNode(data);

    nextItems.push(data);

    if (activeItem) {
      nextPathItems.push(activeItem.active);
    }

    /**
     * 如果是异步更新 data 后，获取到的一个 selectNodeValue，则不更新 activePaths
     * 但是需要更新 items， 因为这里的目的就是把异步更新后的的数据展示出来
     */
    if (selectNodeValue) {
      this.setState({
        items: [].concat(nextItems.reverse(), [newChildren]),
        tempActivePaths: nextPathItems.reverse()
      });
    } else {
      this.setState({
        items: nextItems.reverse(),
        activePaths: nextPathItems.reverse()
      });
    }
  };

  Dropdown.prototype.renderDropdownMenu = function renderDropdownMenu() {
    var _state = this.state,
        items = _state.items,
        tempActivePaths = _state.tempActivePaths,
        activePaths = _state.activePaths;
    var _props2 = this.props,
        renderMenu = _props2.renderMenu,
        placement = _props2.placement,
        renderExtraFooter = _props2.renderExtraFooter,
        menuClassName = _props2.menuClassName,
        menuStyle = _props2.menuStyle;

    var classes = (0, _classnames2.default)(this.addPrefix('cascader-menu'), this.addPrefix('placement-' + (0, _kebabCase3.default)(placement)), menuClassName);

    var menuProps = (0, _pick3.default)(this.props, _DropdownMenu2.default.handledProps.filter(function (name) {
      return name !== 'classPrefix';
    }));

    return React.createElement(
      _Picker.MenuWrapper,
      { className: classes, style: menuStyle },
      React.createElement(_DropdownMenu2.default, _extends({}, menuProps, {
        classPrefix: this.addPrefix('cascader-menu'),
        ref: this.bindMenuContainerRef,
        cascadeItems: items,
        renderMenu: renderMenu,
        cascadePathItems: tempActivePaths || activePaths,
        activeItemValue: this.getValue(),
        onSelect: this.handleSelect
      })),
      renderExtraFooter && renderExtraFooter()
    );
  };

  Dropdown.prototype.render = function render() {
    var _props3 = this.props,
        data = _props3.data,
        valueKey = _props3.valueKey,
        labelKey = _props3.labelKey,
        className = _props3.className,
        placeholder = _props3.placeholder,
        renderValue = _props3.renderValue,
        disabled = _props3.disabled,
        cleanable = _props3.cleanable,
        locale = _props3.locale,
        open = _props3.open,
        defaultOpen = _props3.defaultOpen,
        onClose = _props3.onClose,
        placement = _props3.placement,
        classPrefix = _props3.classPrefix,
        toggleComponentClass = _props3.toggleComponentClass,
        block = _props3.block,
        style = _props3.style,
        container = _props3.container,
        containerPadding = _props3.containerPadding,
        onEnter = _props3.onEnter,
        onEntering = _props3.onEntering,
        onEntered = _props3.onEntered,
        onExit = _props3.onExit,
        onExiting = _props3.onExiting,
        onExited = _props3.onExited,
        appearance = _props3.appearance,
        rest = _objectWithoutProperties(_props3, ['data', 'valueKey', 'labelKey', 'className', 'placeholder', 'renderValue', 'disabled', 'cleanable', 'locale', 'open', 'defaultOpen', 'onClose', 'placement', 'classPrefix', 'toggleComponentClass', 'block', 'style', 'container', 'containerPadding', 'onEnter', 'onEntering', 'onEntered', 'onExit', 'onExiting', 'onExited', 'appearance']);

    var activePaths = this.state.activePaths;

    var unhandled = (0, _utils2.getUnhandledProps)(Dropdown, rest);
    var value = this.getValue();
    var hasValue = !!value;

    var activeItemLabel = placeholder;

    if (renderValue) {
      activeItemLabel = renderValue(activePaths);
    } else if (activePaths.length > 0) {
      activeItemLabel = [];
      activePaths.forEach(function (item, index) {
        var key = item[valueKey] || item[labelKey];
        activeItemLabel.push(React.createElement(
          'span',
          { key: key },
          item[labelKey]
        ));
        if (index < activePaths.length - 1) {
          activeItemLabel.push(React.createElement(
            'span',
            { className: 'separator', key: key + '-separator' },
            ' ',
            '/',
            ' '
          ));
        }
      });
    }

    var classes = (0, _getToggleWrapperClassName2.default)('cascader', this.addPrefix, this.props, hasValue);

    return React.createElement(
      _rsuiteIntl.IntlProvider,
      { locale: locale },
      React.createElement(
        'div',
        {
          className: classes,
          style: style,
          tabIndex: -1,
          role: 'menu',
          ref: this.bindContainerRef
        },
        React.createElement(
          _OverlayTrigger2.default,
          {
            ref: this.bindTriggerRef,
            open: open,
            defaultOpen: defaultOpen,
            disabled: disabled,
            trigger: 'click',
            placement: placement,
            onEnter: (0, _utils2.createChainedFunction)(this.handleEntered, onEnter),
            onEntering: onEntering,
            onEntered: onEntered,
            onExit: onExit,
            onExiting: onExiting,
            onExited: (0, _utils2.createChainedFunction)(this.handleExited, onExited),
            speaker: this.renderDropdownMenu(),
            container: container,
            containerPadding: containerPadding
          },
          React.createElement(
            _PickerToggle2.default,
            _extends({}, unhandled, {
              componentClass: toggleComponentClass,
              onClean: this.handleClean,
              cleanable: cleanable && !disabled,
              hasValue: !!value
            }),
            activeItemLabel || React.createElement(_rsuiteIntl.FormattedMessage, { id: 'placeholder' })
          )
        )
      )
    );
  };

  return Dropdown;
}(React.Component);

Dropdown.defaultProps = {
  appearance: 'default',
  data: [],
  disabledItemValues: [],
  childrenKey: 'children',
  valueKey: 'value',
  labelKey: 'label',
  locale: {
    placeholder: 'Select'
  },
  cleanable: true,
  placement: 'bottomLeft'
};
Dropdown.handledProps = ['appearance', 'block', 'childrenKey', 'className', 'classPrefix', 'cleanable', 'container', 'containerPadding', 'data', 'defaultOpen', 'defaultValue', 'disabled', 'disabledItemValues', 'labelKey', 'locale', 'menuClassName', 'menuHeight', 'menuStyle', 'menuWidth', 'onChange', 'onClose', 'onEnter', 'onEntered', 'onEntering', 'onExit', 'onExited', 'onExiting', 'onOpen', 'onSelect', 'open', 'placeholder', 'placement', 'renderExtraFooter', 'renderMenu', 'renderMenuItem', 'renderValue', 'style', 'toggleComponentClass', 'value', 'valueKey'];
Dropdown.propTypes = {
  appearance: _propTypes2.default.oneOf(['default', 'subtle']).isRequired,
  classPrefix: _propTypes2.default.string.isRequired,
  data: _propTypes2.default.arrayOf(_propTypes2.default.any).isRequired,
  className: _propTypes2.default.string,
  container: _propTypes2.default.oneOfType([function () {
    return (typeof HTMLElement === 'function' ? _propTypes2.default.instanceOf(HTMLElement) : _propTypes2.default.any).apply(this, arguments);
  }, _propTypes2.default.func]),
  containerPadding: _propTypes2.default.number,
  block: _propTypes2.default.bool,
  toggleComponentClass: function toggleComponentClass() {
    return (typeof (React.ElementType == null ? {} : React.ElementType) === 'function' ? _propTypes2.default.instanceOf(React.ElementType == null ? {} : React.ElementType) : _propTypes2.default.any).apply(this, arguments);
  },
  menuClassName: _propTypes2.default.string,
  menuStyle: _propTypes2.default.object,
  childrenKey: _propTypes2.default.string,
  valueKey: _propTypes2.default.string.isRequired,
  labelKey: _propTypes2.default.string.isRequired,
  renderMenu: _propTypes2.default.func,
  renderValue: _propTypes2.default.func,
  renderExtraFooter: _propTypes2.default.func,
  disabled: _propTypes2.default.bool,
  value: _propTypes2.default.any,
  defaultValue: _propTypes2.default.any,
  placeholder: _propTypes2.default.string,
  onChange: _propTypes2.default.func,
  onOpen: _propTypes2.default.func,
  onClose: _propTypes2.default.func,
  onEnter: _propTypes2.default.func,
  onEntering: _propTypes2.default.func,
  onEntered: _propTypes2.default.func,
  onExit: _propTypes2.default.func,
  onExiting: _propTypes2.default.func,
  onExited: _propTypes2.default.func,
  onSelect: _propTypes2.default.func,
  locale: _propTypes2.default.object,
  cleanable: _propTypes2.default.bool,
  open: _propTypes2.default.bool,
  defaultOpen: _propTypes2.default.bool,
  placement: function placement() {
    return (typeof _TypeDefinition.bpfrpt_proptype_Placement === 'function' ? _TypeDefinition.bpfrpt_proptype_Placement : _propTypes2.default.shape(_TypeDefinition.bpfrpt_proptype_Placement)).apply(this, arguments);
  },


  /**
   * Only for `DropdownMenu`
   */
  renderMenuItem: _propTypes2.default.func,
  menuWidth: _propTypes2.default.number,
  menuHeight: _propTypes2.default.number,
  disabledItemValues: _propTypes2.default.arrayOf(_propTypes2.default.any),
  style: _propTypes2.default.object
};


var enhance = (0, _utils2.defaultProps)({
  classPrefix: 'picker'
});

exports.default = enhance(Dropdown);