'use strict';

exports.__esModule = true;

var _isNumber2 = require('lodash/isNumber');

var _isNumber3 = _interopRequireDefault(_isNumber2);

var _isString2 = require('lodash/isString');

var _isString3 = _interopRequireDefault(_isString2);

var _kebabCase2 = require('lodash/kebabCase');

var _kebabCase3 = _interopRequireDefault(_kebabCase2);

var _trim2 = require('lodash/trim');

var _trim3 = _interopRequireDefault(_trim2);

var _isEmpty2 = require('lodash/isEmpty');

var _isEmpty3 = _interopRequireDefault(_isEmpty2);

var _isArray2 = require('lodash/isArray');

var _isArray3 = _interopRequireDefault(_isArray2);

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _domLib = require('dom-lib');

var _reactDom = require('react-dom');

var _OverlayTrigger = require('rsuite-utils/lib/Overlay/OverlayTrigger');

var _OverlayTrigger2 = _interopRequireDefault(_OverlayTrigger);

var _utils = require('rsuite-utils/lib/utils');

var _Picker = require('rsuite-utils/lib/Picker');

var _CheckTreeNode = require('./CheckTreeNode');

var _CheckTreeNode2 = _interopRequireDefault(_CheckTreeNode);

var _constants = require('../utils/constants');

var _utils2 = require('../utils');

var _PickerToggle = require('../_picker/PickerToggle');

var _PickerToggle2 = _interopRequireDefault(_PickerToggle);

var _getToggleWrapperClassName = require('../_picker/getToggleWrapperClassName');

var _getToggleWrapperClassName2 = _interopRequireDefault(_getToggleWrapperClassName);

var _onMenuKeyDown = require('../_picker/onMenuKeyDown');

var _onMenuKeyDown2 = _interopRequireDefault(_onMenuKeyDown);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defaults(obj, defaults) { var keys = Object.getOwnPropertyNames(defaults); for (var i = 0; i < keys.length; i++) { var key = keys[i]; var value = Object.getOwnPropertyDescriptor(defaults, key); if (value && value.configurable && obj[key] === undefined) { Object.defineProperty(obj, key, value); } } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : _defaults(subClass, superClass); }

var CheckTree = function (_React$Component) {
  _inherits(CheckTree, _React$Component);

  function CheckTree(props) {
    _classCallCheck(this, CheckTree);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _initialiseProps.call(_this);

    _this.nodes = {};
    _this.isControlled = 'value' in props;

    var nextValue = _this.getValue(props);
    var expandAll = props.expandAll !== undefined ? props.expandAll : props.defaultExpandAll;
    _this.state = {
      data: [],
      hasValue: true,
      expandAll: expandAll,
      searchKeyword: props.searchKeyword,
      selectedValues: nextValue,
      formattedNodes: [],
      isSomeNodeHasChildren: _this.isSomeNodeHasChildren(props.data)
    };
    return _this;
  }

  CheckTree.prototype.componentWillMount = function componentWillMount() {
    var searchKeyword = this.state.searchKeyword;
    var data = this.props.data;

    var nextValue = this.getValue(this.props);
    var nextData = (0, _utils2.clone)(data);
    this.flattenNodes(nextData);
    this.unserializeLists({
      check: nextValue
    });
    this.setState({
      data: this.getFilterData(searchKeyword, nextData),
      hasValue: this.hasValue()
    });
  };

  CheckTree.prototype.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
    var _state = this.state,
        searchKeyword = _state.searchKeyword,
        selectedValues = _state.selectedValues;
    var _nextProps$value = nextProps.value,
        value = _nextProps$value === undefined ? [] : _nextProps$value,
        _nextProps$data = nextProps.data,
        data = _nextProps$data === undefined ? [] : _nextProps$data,
        cascade = nextProps.cascade,
        expandAll = nextProps.expandAll;


    if ((0, _isArray3.default)(data) && (0, _isArray3.default)(this.props.data) && !(0, _utils.shallowEqualArray)(this.props.data, data)) {
      var nextData = (0, _utils2.clone)(data);
      this.flattenNodes(nextData);
      this.unserializeLists({
        check: this.getValue(nextProps)
      });
      this.setState({
        data: this.getFilterData(searchKeyword, nextData),
        isSomeNodeHasChildren: this.isSomeNodeHasChildren(nextData),
        hasValue: this.hasValue()
      });
    }
    if ((0, _isArray3.default)(value) && (0, _isArray3.default)(this.props.value) && !(0, _utils.shallowEqualArray)(value, this.props.value)) {
      var nextState = {
        selectedValues: value,
        hasValue: this.hasValue(value),
        activeNode: this.activeNode
      };

      if (!value.length) {
        nextState.activeNode = null;
      }
      this.unserializeLists({
        check: nextProps.value
      });
      this.setState(nextState);
    }

    // cascade 改变时，重新初始化
    if (cascade !== this.props.cascade && cascade) {
      this.flattenNodes(this.state.data);
      this.unserializeLists({
        check: selectedValues
      }, nextProps);
    }

    if (nextProps.searchKeyword !== this.props.searchKeyword) {
      this.setState({
        data: this.getFilterData(nextProps.searchKeyword, this.state.data),
        searchKeyword: nextProps.searchKeyword
      });
    }

    if (expandAll !== this.props.expandAll) {
      this.setState({
        expandAll: expandAll
      });
    }
  };

  CheckTree.prototype.getNodeCheckState = function getNodeCheckState(node, cascade) {
    var childrenKey = this.props.childrenKey;

    if (!node[childrenKey] || !node[childrenKey].length || !cascade) {
      return node.check ? _constants.CHECK_STATE.CHECK : _constants.CHECK_STATE.UNCHECK;
    }

    if (this.isEveryChildChecked(node)) {
      return _constants.CHECK_STATE.CHECK;
    }

    if (this.isSomeChildChecked(node)) {
      return _constants.CHECK_STATE.INDETERMINATE;
    }

    return _constants.CHECK_STATE.UNCHECK;
  };

  CheckTree.prototype.getExpandState = function getExpandState(node) {
    var expandAll = this.state.expandAll;
    var childrenKey = this.props.childrenKey;

    if (node[childrenKey] && node[childrenKey].length) {
      if ('expand' in node) {
        return !!node.expand;
      } else if (expandAll) {
        return true;
      }
      return false;
    }
    return false;
  };

  CheckTree.prototype.getFilterData = function getFilterData() {
    var searchKeyword = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';

    var _this2 = this;

    var data = arguments[1];
    var props = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : this.props;
    var labelKey = props.labelKey;

    var setVisible = function setVisible() {
      var nodes = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
      return nodes.forEach(function (item) {
        item.visible = _this2.shouldDisplay(item[labelKey], searchKeyword);
        if ((0, _isArray3.default)(item.children)) {
          setVisible(item.children);
          item.children.forEach(function (child) {
            if (child.visible) {
              item.visible = child.visible;
            }
          });
        }
      });
    };

    setVisible(data);
    return data;
  };

  CheckTree.prototype.getActiveElementOption = function getActiveElementOption(options, refKey) {
    for (var i = 0; i < options.length; i += 1) {
      if (options[i].refKey === refKey) {
        return options[i];
      } else if (options[i].children && options[i].children.length) {
        var active = this.getActiveElementOption(options[i].children, refKey);
        if (!(0, _isEmpty3.default)(active)) {
          return active;
        }
      }
    }
    return {};
  };

  CheckTree.prototype.getFormattedNodes = function getFormattedNodes(nodes) {
    var _this3 = this;

    return nodes.map(function (node) {
      var formatted = _extends({}, node);
      var curNode = _this3.nodes[node.refKey];
      formatted.check = curNode.check;
      formatted.expand = curNode.expand;
      formatted.disabledCheckbox = curNode.disabledCheckbox;
      formatted.parentNode = curNode.parentNode;
      if (Array.isArray(node.children) && node.children.length > 0) {
        formatted.children = _this3.getFormattedNodes(formatted.children);
      }
      return formatted;
    });
  };

  /**
   * 获取每个节点的disable状态
   * @param {*} node
   */


  CheckTree.prototype.getDisabledState = function getDisabledState(node) {
    var _this4 = this;

    var _props = this.props,
        _props$disabledItemVa = _props.disabledItemValues,
        disabledItemValues = _props$disabledItemVa === undefined ? [] : _props$disabledItemVa,
        valueKey = _props.valueKey;

    return disabledItemValues.some(function (value) {
      return (0, _utils.shallowEqual)(_this4.nodes[node.refKey][valueKey], value);
    });
  };

  /**
   * 获取每个节点的是否需要 disabled checkbox
   * @param {*} node
   */


  CheckTree.prototype.getDisabledCheckboxState = function getDisabledCheckboxState(node) {
    var _props2 = this.props,
        _props2$disabledCheck = _props2.disabledCheckboxValues,
        disabledCheckboxValues = _props2$disabledCheck === undefined ? [] : _props2$disabledCheck,
        valueKey = _props2.valueKey;

    return disabledCheckboxValues.some(function (value) {
      return (0, _utils.shallowEqual)(node[valueKey], value);
    });
  };

  CheckTree.prototype.getItemsAndActiveIndex = function getItemsAndActiveIndex() {
    var items = this.getFocusableMenuItems();

    var activeIndex = -1;
    items.forEach(function (item, index) {
      if (document.activeElement !== null) {
        if (item.refKey === document.activeElement.getAttribute('data-key')) {
          activeIndex = index;
        }
      }
    });
    return { items: items, activeIndex: activeIndex };
  };

  CheckTree.prototype.getActiveItem = function getActiveItem() {
    var data = this.state.data;

    var activeItem = document.activeElement;
    if (activeItem !== null) {
      var _activeItem$dataset = activeItem.dataset,
          key = _activeItem$dataset.key,
          _layer = _activeItem$dataset.layer;

      var _nodeData = this.getActiveElementOption(data, key);
      _nodeData.check = !this.nodes[_nodeData.refKey].check;
      _nodeData.parentNode = this.nodes[_nodeData.refKey].parentNode;
      return {
        nodeData: _nodeData,
        layer: _layer
      };
    }
    return {};
  };

  /**
   * 判断传入的 value 是否存在于data 中
   * @param {*} values
   */


  CheckTree.prototype.hasValue = function hasValue() {
    var _this5 = this;

    var values = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.state.selectedValues;
    var valueKey = this.props.valueKey;

    var selectedValues = Object.keys(this.nodes).map(function (refKey) {
      return _this5.nodes[refKey][valueKey];
    }).filter(function (item) {
      return values.some(function (v) {
        return (0, _utils.shallowEqual)(v, item);
      });
    });
    return !!selectedValues.length;
  };

  /**
   * 判断第一层节点是否存在有children的节点
   * @param {*} data
   */


  CheckTree.prototype.isEveryChildChecked = function isEveryChildChecked(node) {
    var _this6 = this;

    var childrenKey = this.props.childrenKey;

    return node[childrenKey].every(function (child) {
      if (child[childrenKey] && child[childrenKey].length) {
        return _this6.isEveryChildChecked(child);
      }
      return child.check;
    });
  };

  CheckTree.prototype.isSomeChildChecked = function isSomeChildChecked(node) {
    var _this7 = this;

    var childrenKey = this.props.childrenKey;

    return node[childrenKey].some(function (child) {
      if (child[childrenKey] && child[childrenKey].length) {
        return _this7.isSomeChildChecked(child);
      }

      return child.check;
    });
  };

  /**
   * 拍平数组，将tree 转换为一维数组
   * @param {*} nodes tree data
   * @param {*} ref 当前层级
   */


  CheckTree.prototype.flattenNodes = function flattenNodes(nodes) {
    var props = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : this.props;

    var _this8 = this;

    var ref = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : '0';
    var parentNode = arguments[3];
    var labelKey = props.labelKey,
        valueKey = props.valueKey,
        childrenKey = props.childrenKey;


    if (!Array.isArray(nodes) || nodes.length === 0) {
      return;
    }
    nodes.forEach(function (node, index) {
      var _this8$nodes$refKey;

      var refKey = ref + '-' + index;
      node.refKey = refKey;
      _this8.nodes[refKey] = (_this8$nodes$refKey = {}, _this8$nodes$refKey[labelKey] = node[labelKey], _this8$nodes$refKey[valueKey] = node[valueKey], _this8$nodes$refKey.expand = _this8.getExpandState(node), _this8$nodes$refKey.disabledCheckbox = _this8.getDisabledCheckboxState(node), _this8$nodes$refKey.refKey = refKey, _this8$nodes$refKey);
      if (parentNode) {
        _this8.nodes[refKey].parentNode = parentNode;
      }
      _this8.flattenNodes(node[childrenKey], props, refKey, _this8.nodes[refKey]);
    });
  };

  CheckTree.prototype.serializeList = function serializeList(key) {
    var nodes = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : this.nodes;
    var valueKey = this.props.valueKey;

    var list = [];

    Object.keys(nodes).forEach(function (refKey) {
      if (nodes[refKey][key]) {
        list.push(nodes[refKey][valueKey]);
      }
    });
    return list;
  };

  CheckTree.prototype.unserializeLists = function unserializeLists(lists) {
    var _this9 = this;

    var nextProps = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : this.props;
    var valueKey = nextProps.valueKey,
        cascade = nextProps.cascade;
    // Reset values to false

    Object.keys(this.nodes).forEach(function (refKey) {
      Object.keys(lists).forEach(function (listKey) {
        var node = _this9.nodes[refKey];
        if (cascade && 'parentNode' in node) {
          node[listKey] = node.parentNode[listKey];
        } else {
          node[listKey] = false;
        }
        lists[listKey].forEach(function (value) {
          if ((0, _utils.shallowEqual)(_this9.nodes[refKey][valueKey], value)) {
            _this9.nodes[refKey][listKey] = true;
          }
        });
      });
    });
  };

  // for test


  CheckTree.prototype.toggleChecked = function toggleChecked(node, isChecked) {
    var nodes = (0, _utils2.clone)(this.nodes);
    this.toggleDownChecked(nodes, node, isChecked);
    node.parentNode && this.toggleUpChecked(nodes, node.parentNode, isChecked);
    return this.serializeList('check', nodes);
  };

  CheckTree.prototype.toggleUpChecked = function toggleUpChecked(nodes, node, checked) {
    var cascade = this.props.cascade;


    if (cascade) {
      if (!checked) {
        nodes[node.refKey].check = checked;
      } else {
        if (this.everyChildChecked(nodes, node)) {
          nodes[node.refKey].check = checked;
        } else {
          nodes[node.refKey].check = false;
        }
      }
      if (node.parentNode) {
        this.toggleUpChecked(nodes, node.parentNode, checked);
      }
    }
  };

  CheckTree.prototype.toggleDownChecked = function toggleDownChecked(nodes, node, isChecked) {
    var _this10 = this;

    var _props3 = this.props,
        childrenKey = _props3.childrenKey,
        cascade = _props3.cascade;

    if (!node[childrenKey] || !node[childrenKey].length || !cascade) {
      nodes[node.refKey].check = isChecked;
    } else {
      nodes[node.refKey].check = isChecked;
      node.children.forEach(function (child) {
        _this10.toggleDownChecked(nodes, child, isChecked);
      });
    }
  };

  CheckTree.prototype.toggleNode = function toggleNode(key, node, toggleValue) {
    // 如果该节点处于 disabledChecbox，则忽略该值
    if (!node.disabledCheckbox) {
      this.nodes[node.refKey][key] = toggleValue;
    }
  };

  CheckTree.prototype.toggleExpand = function toggleExpand(node, isExpand) {
    this.nodes[node.refKey].expand = isExpand;
  };

  /**
   * 选择某个节点后的回调函数
   * @param {object} activeNodeData   节点的数据
   * @param {number} layer            节点的层级
   */


  /**
   * 展开、收起节点
   */


  /**
   * 展开树节点后的回调函数
   */


  /**
   * 处理键盘方向键移动
   */


  /**
   * 清除已选择的项
   */


  CheckTree.prototype.renderDropdownMenu = function renderDropdownMenu() {
    var _props4 = this.props,
        locale = _props4.locale,
        searchable = _props4.searchable,
        placement = _props4.placement,
        renderExtraFooter = _props4.renderExtraFooter,
        renderMenu = _props4.renderMenu,
        menuStyle = _props4.menuStyle,
        menuClassName = _props4.menuClassName;

    var classes = (0, _classnames2.default)(menuClassName, this.addPrefix('checktree-menu'), this.addPrefix('placement-' + (0, _kebabCase3.default)(placement)));
    var menu = this.renderCheckTree();

    return React.createElement(
      _Picker.MenuWrapper,
      { className: classes, style: menuStyle, ref: this.bindMenuRef },
      searchable ? React.createElement(_Picker.SearchBar, {
        placeholder: locale.searchPlaceholder,
        key: 'searchBar',
        onChange: this.handleSearch,
        value: this.state.searchKeyword
      }) : null,
      renderMenu ? renderMenu(menu) : menu,
      renderExtraFooter && renderExtraFooter()
    );
  };

  CheckTree.prototype.renderNode = function renderNode(node, index, layer, classPrefix) {
    var _this11 = this;

    var _state2 = this.state,
        activeNode = _state2.activeNode,
        expandAll = _state2.expandAll;
    var _props5 = this.props,
        valueKey = _props5.valueKey,
        labelKey = _props5.labelKey,
        childrenKey = _props5.childrenKey,
        renderTreeNode = _props5.renderTreeNode,
        renderTreeIcon = _props5.renderTreeIcon,
        cascade = _props5.cascade;


    var refKey = node.refKey;
    var key = (0, _isString3.default)(node[valueKey]) || (0, _isNumber3.default)(node[valueKey]) ? node[valueKey] : refKey;

    var children = node[childrenKey];
    var hasNotEmptyChildren = children && Array.isArray(children) && children.length > 0;

    var props = {
      value: node[valueKey],
      label: node[labelKey],
      index: index,
      layer: layer,
      active: activeNode ? (0, _utils.shallowEqual)(activeNode[valueKey], node[valueKey]) : false,
      visible: node.visible,
      disabled: this.getDisabledState(node),
      nodeData: node,
      children: children,
      expandAll: expandAll,
      checkState: this.getNodeCheckState(node, cascade),
      parentNode: node.parentNode,
      hasChildren: !!children,
      disabledCheckbox: node.disabledCheckbox,
      onSelect: this.handleSelect,
      onTreeToggle: this.handleToggle,
      onRenderTreeNode: renderTreeNode,
      onRenderTreeIcon: renderTreeIcon
    };

    if (props.hasChildren) {
      var _classNames;

      layer += 1;

      // 是否展开树节点且子节点不为空
      var openClass = classPrefix + '-open';
      var expandControlled = 'expandAll' in this.props;
      var expandALlState = expandControlled ? expandAll : expandAll || node.expand;
      var childrenClass = (0, _classnames2.default)(classPrefix + '-node-children', (_classNames = {}, _classNames[openClass] = expandALlState && hasNotEmptyChildren, _classNames));

      var nodes = children || [];
      return React.createElement(
        'div',
        { className: childrenClass, key: key, ref: this.bindNodeRefs.bind(this, refKey) },
        React.createElement(_CheckTreeNode2.default, _extends({
          classPrefix: classPrefix,
          key: key,
          ref: this.bindNodeRefs.bind(this, refKey)
        }, props)),
        React.createElement(
          'div',
          { className: classPrefix + '-children' },
          nodes.map(function (child, i) {
            return _this11.renderNode(child, i, layer, classPrefix);
          })
        )
      );
    }

    return React.createElement(_CheckTreeNode2.default, _extends({
      classPrefix: classPrefix,
      key: key,
      ref: this.bindNodeRefs.bind(this, refKey)
    }, props));
  };

  CheckTree.prototype.renderCheckTree = function renderCheckTree() {
    var _this12 = this;

    var _state3 = this.state,
        data = _state3.data,
        isSomeNodeHasChildren = _state3.isSomeNodeHasChildren;
    var onScroll = this.props.onScroll;
    // 树节点的层级

    var layer = 0;
    var height = this.props.height;

    var treeViewClass = this.addPrefix('checktree-view');
    var classes = (0, _classnames2.default)(treeViewClass, {
      'without-children': !isSomeNodeHasChildren
    });
    var formattedNodes = this.state.formattedNodes.length ? this.state.formattedNodes : this.getFormattedNodes(data);

    var nodes = formattedNodes.map(function (node, index) {
      return _this12.renderNode(node, index, layer, treeViewClass);
    });
    var styles = {
      height: height
    };
    var treeNodesClass = this.addPrefix('checktree-nodes');
    return React.createElement(
      'div',
      {
        ref: this.bindTreeViewRef,
        className: classes,
        style: styles,
        onScroll: onScroll,
        onKeyDown: this.handleKeyDown
      },
      React.createElement(
        'div',
        { className: treeNodesClass },
        nodes
      )
    );
  };

  CheckTree.prototype.render = function render() {
    var _this13 = this;

    var _props6 = this.props,
        open = _props6.open,
        block = _props6.block,
        style = _props6.style,
        locale = _props6.locale,
        inline = _props6.inline,
        disabled = _props6.disabled,
        valueKey = _props6.valueKey,
        cleanable = _props6.cleanable,
        className = _props6.className,
        placement = _props6.placement,
        appearance = _props6.appearance,
        classPrefix = _props6.classPrefix,
        defaultOpen = _props6.defaultOpen,
        placeholder = _props6.placeholder,
        container = _props6.container,
        containerPadding = _props6.containerPadding,
        toggleComponentClass = _props6.toggleComponentClass,
        onExit = _props6.onExit,
        onOpen = _props6.onOpen,
        onClose = _props6.onClose,
        onEnter = _props6.onEnter,
        onExited = _props6.onExited,
        onExiting = _props6.onExiting,
        onEntered = _props6.onEntered,
        onEntering = _props6.onEntering,
        renderValue = _props6.renderValue,
        rest = _objectWithoutProperties(_props6, ['open', 'block', 'style', 'locale', 'inline', 'disabled', 'valueKey', 'cleanable', 'className', 'placement', 'appearance', 'classPrefix', 'defaultOpen', 'placeholder', 'container', 'containerPadding', 'toggleComponentClass', 'onExit', 'onOpen', 'onClose', 'onEnter', 'onExited', 'onExiting', 'onEntered', 'onEntering', 'renderValue']);

    var hasValue = this.state.hasValue;


    var selectedValues = this.serializeList('check');

    var classes = (0, _getToggleWrapperClassName2.default)('checktree', this.addPrefix, this.props, hasValue);

    var placeholderText = placeholder;
    if (hasValue && selectedValues.length) {
      placeholderText = (0, _utils.tplTransform)(locale.selectedValues, selectedValues.length);
    }
    if (renderValue && hasValue) {
      var _checkItems = [];
      Object.keys(this.nodes).map(function (refKey) {
        var node = _this13.nodes[refKey];
        if (selectedValues.some(function (value) {
          return (0, _utils.shallowEqual)(node[valueKey], value);
        })) {
          _checkItems.push(node);
        }
      });
      placeholderText = renderValue(selectedValues, _checkItems, placeholderText);
    }
    var unhandled = (0, _utils2.getUnhandledProps)(CheckTree, rest);

    return !inline ? React.createElement(
      'div',
      {
        onKeyDown: this.handleToggleKeyDown,
        className: classes,
        style: style,
        tabIndex: -1,
        role: 'menu',
        ref: this.bindContainerRef
      },
      React.createElement(
        _OverlayTrigger2.default,
        {
          ref: this.bindTriggerRef,
          open: open,
          defaultOpen: defaultOpen,
          disabled: disabled,
          trigger: 'click',
          placement: placement,
          onEnter: onEnter,
          onEntering: onEntering,
          onEntered: (0, _utils2.createChainedFunction)(this.handleOnOpen, onEntered),
          onExit: onExit,
          onExiting: onExiting,
          onExited: (0, _utils2.createChainedFunction)(this.handleOnClose, onExited),
          container: container,
          containerPadding: containerPadding,
          speaker: this.renderDropdownMenu()
        },
        React.createElement(
          _PickerToggle2.default,
          _extends({}, unhandled, {
            onClean: this.handleClean,
            componentClass: toggleComponentClass,
            cleanable: cleanable && !disabled,
            hasValue: hasValue
          }),
          placeholderText || locale.placeholder
        )
      )
    ) : this.renderCheckTree();
  };

  return CheckTree;
}(React.Component);

CheckTree.defaultProps = {
  locale: {
    placeholder: 'Select',
    searchPlaceholder: 'Search',
    selectedValues: '{0} selected'
  },
  cascade: true,
  valueKey: 'value',
  labelKey: 'label',
  cleanable: true,
  placement: 'bottomLeft',
  appearance: 'default',
  searchable: true,
  defaultValue: [],
  childrenKey: 'children',
  searchKeyword: '',
  disabledItemValues: [],
  disabledCheckboxValues: []
};
CheckTree.handledProps = ['appearance', 'block', 'cascade', 'childrenKey', 'className', 'classPrefix', 'cleanable', 'container', 'containerPadding', 'data', 'defaultExpandAll', 'defaultOpen', 'defaultValue', 'disabled', 'disabledCheckboxValues', 'disabledItemValues', 'expandAll', 'height', 'inline', 'labelKey', 'locale', 'menuClassName', 'menuStyle', 'onChange', 'onClose', 'onEnter', 'onEntered', 'onEntering', 'onExit', 'onExited', 'onExiting', 'onExpand', 'onOpen', 'onScroll', 'onSearch', 'onSelect', 'open', 'placeholder', 'placement', 'renderExtraFooter', 'renderMenu', 'renderTreeIcon', 'renderTreeNode', 'renderValue', 'searchKeyword', 'searchable', 'style', 'toggleComponentClass', 'value', 'valueKey'];
CheckTree.propTypes = {
  data: _propTypes2.default.arrayOf(_propTypes2.default.any).isRequired,
  open: _propTypes2.default.bool,
  block: _propTypes2.default.bool,
  style: _propTypes2.default.object,
  value: _propTypes2.default.arrayOf(_propTypes2.default.any),
  height: _propTypes2.default.number,
  inline: _propTypes2.default.bool,
  locale: _propTypes2.default.object.isRequired,
  cascade: _propTypes2.default.bool.isRequired,
  disabled: _propTypes2.default.bool,
  valueKey: _propTypes2.default.string.isRequired,
  labelKey: _propTypes2.default.string.isRequired,
  container: _propTypes2.default.oneOfType([function () {
    return (typeof HTMLElement === 'function' ? _propTypes2.default.instanceOf(HTMLElement) : _propTypes2.default.any).apply(this, arguments);
  }, _propTypes2.default.func]),
  className: _propTypes2.default.string,
  cleanable: _propTypes2.default.bool,
  expandAll: _propTypes2.default.bool,
  placement: _propTypes2.default.oneOf(['bottomLeft', 'bottomRight', 'topLeft', 'topRight', 'leftTop', 'rightTop', 'leftBottom', 'rightBottom', 'auto', 'autoVerticalLeft', 'autoVerticalRight', 'autoHorizontalTop', 'autoHorizontalBottom']),
  menuStyle: _propTypes2.default.object,
  searchable: _propTypes2.default.bool,
  appearance: _propTypes2.default.oneOf(['default', 'subtle']).isRequired,
  classPrefix: _propTypes2.default.string.isRequired,
  defaultOpen: _propTypes2.default.bool,
  childrenKey: _propTypes2.default.string,
  placeholder: _propTypes2.default.node,
  defaultValue: _propTypes2.default.arrayOf(_propTypes2.default.any),
  searchKeyword: _propTypes2.default.string,
  menuClassName: _propTypes2.default.string,
  defaultExpandAll: _propTypes2.default.bool,
  containerPadding: _propTypes2.default.number,
  disabledItemValues: _propTypes2.default.arrayOf(_propTypes2.default.any),
  toggleComponentClass: function toggleComponentClass() {
    return (typeof (React.ElementType == null ? {} : React.ElementType) === 'function' ? _propTypes2.default.instanceOf(React.ElementType == null ? {} : React.ElementType) : _propTypes2.default.any).apply(this, arguments);
  },

  // 禁用 checkbox 数组
  disabledCheckboxValues: _propTypes2.default.arrayOf(_propTypes2.default.any).isRequired,
  onOpen: _propTypes2.default.func,
  onExit: _propTypes2.default.func,
  onEnter: _propTypes2.default.func,
  onClose: _propTypes2.default.func,
  onSearch: _propTypes2.default.func,
  onChange: _propTypes2.default.func,
  onExpand: _propTypes2.default.func,
  onSelect: _propTypes2.default.func,
  onScroll: _propTypes2.default.func,
  onExited: _propTypes2.default.func,
  onEntered: _propTypes2.default.func,
  onExiting: _propTypes2.default.func,
  onEntering: _propTypes2.default.func,
  renderMenu: _propTypes2.default.func,
  renderValue: _propTypes2.default.func,
  renderTreeNode: _propTypes2.default.func,
  renderTreeIcon: _propTypes2.default.func,
  renderExtraFooter: _propTypes2.default.func
};

var _initialiseProps = function _initialiseProps() {
  var _this14 = this;

  this.getValue = function (props) {
    var value = props.value,
        defaultValue = props.defaultValue;

    if (value && value.length) {
      return value;
    }
    if (defaultValue && defaultValue.length > 0) {
      return defaultValue;
    }
    return [];
  };

  this.getElementByDataKey = function (dataKey) {
    var ele = (0, _reactDom.findDOMNode)(_this14.nodeRefs[dataKey]);
    if (ele instanceof Element) {
      return ele.querySelector('.rs-picker-checktree-view-checknode-label');
    }
    return null;
  };

  this.getFocusableMenuItems = function () {
    var data = _this14.state.data;
    var childrenKey = _this14.props.childrenKey;


    var items = [];
    var loop = function loop(treeNodes) {
      treeNodes.forEach(function (node) {
        if (!_this14.getDisabledState(node) && !_this14.getDisabledCheckboxState(node) && node.visible) {
          items.push(node);
          var _nodeData2 = _extends({}, node, _this14.nodes[node.refKey]);
          if (!_this14.getExpandState(_nodeData2)) {
            return;
          }
          if (node[childrenKey]) {
            loop(node[childrenKey]);
          }
        }
      });
    };

    loop(data);
    return items;
  };

  this.isSomeNodeHasChildren = function (data) {
    return data.some(function (node) {
      return node.children;
    });
  };

  this.shouldDisplay = function (label, searchKeyword) {
    if (!(0, _trim3.default)(searchKeyword)) {
      return true;
    }
    var keyword = searchKeyword.toLocaleLowerCase();
    if (typeof label === 'string') {
      return label.toLocaleLowerCase().indexOf(keyword) >= 0;
    } else if (React.isValidElement(label)) {
      var nodes = (0, _utils.reactToString)(label);
      return nodes.join('').toLocaleLowerCase().indexOf(keyword) >= 0;
    }
    return false;
  };

  this.isControlled = null;
  this.nodes = {};
  this.activeNode = null;
  this.treeView = null;

  this.bindTreeViewRef = function (ref) {
    _this14.treeView = ref;
  };

  this.trigger = null;

  this.bindTriggerRef = function (ref) {
    _this14.trigger = ref;
  };

  this.container = null;

  this.bindContainerRef = function (ref) {
    _this14.container = ref;
  };

  this.nodeRefs = {};

  this.bindNodeRefs = function (refKey, ref) {
    _this14.nodeRefs[refKey] = ref;
  };

  this.menu = null;

  this.bindMenuRef = function (ref) {
    _this14.menu = ref;
  };

  this.selectActiveItem = function () {
    var _getActiveItem = _this14.getActiveItem(),
        nodeData = _getActiveItem.nodeData,
        layer = _getActiveItem.layer;

    _this14.handleSelect(nodeData, +layer);
  };

  this.focusNextItem = function () {
    var _getItemsAndActiveInd = _this14.getItemsAndActiveIndex(),
        items = _getItemsAndActiveInd.items,
        activeIndex = _getItemsAndActiveInd.activeIndex;

    if (items.length === 0) {
      return;
    }
    var nextIndex = activeIndex === items.length - 1 ? 0 : activeIndex + 1;
    var node = _this14.getElementByDataKey(items[nextIndex].refKey);
    if (node !== null) {
      node.focus();
    }
  };

  this.focusPreviousItem = function () {
    var _getItemsAndActiveInd2 = _this14.getItemsAndActiveIndex(),
        items = _getItemsAndActiveInd2.items,
        activeIndex = _getItemsAndActiveInd2.activeIndex;

    if (items.length === 0) {
      return;
    }
    var prevIndex = activeIndex === 0 ? items.length - 1 : activeIndex - 1;
    prevIndex = prevIndex >= 0 ? prevIndex : 0;
    var node = _this14.getElementByDataKey(items[prevIndex].refKey);
    if (node !== null) {
      node.focus();
    }
  };

  this.everyChildChecked = function (nodes, node) {
    var list = [];
    Object.keys(nodes).filter(function (refKey) {
      var curNode = nodes[refKey];
      if (curNode.parentNode && curNode.parentNode.refKey === node.refKey) {
        list.push(curNode);
      }
    });

    return list.every(function (l) {
      return l.check;
    });
  };

  this.addPrefix = function (name) {
    return (0, _utils2.prefix)(_this14.props.classPrefix)(name);
  };

  this.handleSelect = function (activeNode, layer) {
    var _props7 = _this14.props,
        onChange = _props7.onChange,
        onSelect = _props7.onSelect;

    var selectedValues = _this14.toggleChecked(activeNode, activeNode.check);
    if (_this14.isControlled) {
      _this14.activeNode = activeNode;
    } else {
      _this14.unserializeLists({
        check: selectedValues
      });
      _this14.setState({
        activeNode: activeNode,
        selectedValues: selectedValues,
        hasValue: !!selectedValues.length
      });
    }

    onChange && onChange(selectedValues);
    onSelect && onSelect(activeNode, layer, selectedValues);
  };

  this.handleToggle = function (nodeData, layer) {
    var _props8 = _this14.props,
        _props8$classPrefix = _props8.classPrefix,
        classPrefix = _props8$classPrefix === undefined ? '' : _props8$classPrefix,
        onExpand = _props8.onExpand;

    var openClass = classPrefix + '-checktree-view-open';
    (0, _domLib.toggleClass)((0, _reactDom.findDOMNode)(_this14.nodeRefs[nodeData.refKey]), openClass);
    nodeData.expand = (0, _domLib.hasClass)((0, _reactDom.findDOMNode)(_this14.nodeRefs[nodeData.refKey]), openClass);
    _this14.toggleExpand(nodeData, nodeData.expand);
    onExpand && onExpand(nodeData, layer);
  };

  this.handleExpand = function (activeNode, layer) {
    var onExpand = _this14.props.onExpand;

    onExpand && onExpand(activeNode, layer);
  };

  this.handleKeyDown = function (event) {
    (0, _onMenuKeyDown2.default)(event, {
      down: _this14.focusNextItem,
      up: _this14.focusPreviousItem,
      enter: _this14.selectActiveItem
    });
  };

  this.handleToggleKeyDown = function (event) {
    var classPrefix = _this14.props.classPrefix;

    if (!_this14.treeView) {
      return;
    }
    if (event.target instanceof HTMLElement) {
      var _className = event.target.className;
      if (_className.includes(classPrefix + '-toggle') || _className.includes(classPrefix + '-toggle-custom') || _className.includes(classPrefix + '-search-bar-input')) {
        (0, _onMenuKeyDown2.default)(event, {
          down: _this14.focusNextItem
        });
      }
    }
  };

  this.handleSearch = function (value, event) {
    var data = _this14.state.data;
    var onSearch = _this14.props.onSearch;

    _this14.setState({
      searchKeyword: value,
      data: _this14.getFilterData(value, data)
    });

    onSearch && onSearch(value, event);
  };

  this.handleClean = function () {
    var onChange = _this14.props.onChange;

    _this14.setState({
      selectedValues: [],
      hasValue: false,
      activeNode: {}
    });
    _this14.unserializeLists({
      check: []
    });

    onChange && onChange([]);
  };

  this.handleOnOpen = function () {
    var activeNode = _this14.state.activeNode;
    var onOpen = _this14.props.onOpen;

    if (activeNode) {
      var node = _this14.getElementByDataKey(activeNode.refKey);
      if (node !== null) {
        node.focus();
      }
    }

    onOpen && onOpen();
  };

  this.handleOnClose = function () {
    var onClose = _this14.props.onClose;

    onClose && onClose();
  };
};

var enhance = (0, _utils2.defaultProps)({
  classPrefix: 'picker'
});
exports.default = enhance(CheckTree);