'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _utils = require('../../utils');

var _MonthDropdown = require('../../Calendar/MonthDropdown');

var _MonthDropdown2 = _interopRequireDefault(_MonthDropdown);

var _Header = require('../../Calendar/Header');

var _Header2 = _interopRequireDefault(_Header);

var _View = require('./View');

var _View2 = _interopRequireDefault(_View);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _defaults(obj, defaults) { var keys = Object.getOwnPropertyNames(defaults); for (var i = 0; i < keys.length; i++) { var key = keys[i]; var value = Object.getOwnPropertyDescriptor(defaults, key); if (value && value.configurable && obj[key] === undefined) { Object.defineProperty(obj, key, value); } } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : _defaults(subClass, superClass); }

var Calendar = function (_React$Component) {
  _inherits(Calendar, _React$Component);

  function Calendar() {
    var _temp, _this, _ret;

    _classCallCheck(this, Calendar);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _React$Component.call.apply(_React$Component, [this].concat(args))), _this), _this.handleMoveForword = function () {
      var onMoveForword = _this.props.onMoveForword;

      onMoveForword && onMoveForword(_this.getPageDate().clone().add(1, 'month'));
    }, _this.handleMoveBackward = function () {
      var onMoveBackward = _this.props.onMoveBackward;

      onMoveBackward && onMoveBackward(_this.getPageDate().clone().add(-1, 'month'));
    }, _this.disabledBackward = function () {
      var _this$props = _this.props,
          calendarDate = _this$props.calendarDate,
          index = _this$props.index;

      var isAfter = calendarDate[1].isAfter(calendarDate[0].clone().add(1, 'month'), 'month');

      if (index === 0) {
        return false;
      }

      if (!isAfter) {
        return true;
      }

      return false;
    }, _this.disabledForword = function () {
      var _this$props2 = _this.props,
          calendarDate = _this$props2.calendarDate,
          index = _this$props2.index;

      var isAfter = calendarDate[1].isAfter(calendarDate[0].clone().add(1, 'month'), 'month');

      if (index === 1) {
        return false;
      }

      if (!isAfter) {
        return true;
      }

      return false;
    }, _this.disabledMonth = function (date) {
      var _this$props3 = _this.props,
          calendarDate = _this$props3.calendarDate,
          index = _this$props3.index;

      var isAfter = true;

      if (index === 1) {
        isAfter = date.isAfter(calendarDate[0], 'month');
        return !isAfter;
      }

      isAfter = calendarDate[1].isAfter(date, 'month');
      return !isAfter;
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  Calendar.prototype.getPageDate = function getPageDate() {
    var _props = this.props,
        calendarDate = _props.calendarDate,
        index = _props.index;

    return calendarDate[index];
  };

  Calendar.prototype.shouldMountDate = function shouldMountDate(props) {
    var _ref = props || this.props,
        format = _ref.format;

    return (/Y/.test(format) && /M/.test(format) && /D/.test(format)
    );
  };

  Calendar.prototype.render = function render() {
    var _classNames;

    var _props2 = this.props,
        calendarState = _props2.calendarState,
        onSelect = _props2.onSelect,
        onMouseMove = _props2.onMouseMove,
        onToggleMonthDropdown = _props2.onToggleMonthDropdown,
        onChangePageDate = _props2.onChangePageDate,
        format = _props2.format,
        disabledDate = _props2.disabledDate,
        className = _props2.className,
        value = _props2.value,
        hoverValue = _props2.hoverValue,
        isoWeek = _props2.isoWeek,
        limitStartYear = _props2.limitStartYear,
        limitEndYear = _props2.limitEndYear,
        classPrefix = _props2.classPrefix,
        rest = _objectWithoutProperties(_props2, ['calendarState', 'onSelect', 'onMouseMove', 'onToggleMonthDropdown', 'onChangePageDate', 'format', 'disabledDate', 'className', 'value', 'hoverValue', 'isoWeek', 'limitStartYear', 'limitEndYear', 'classPrefix']);

    var pageDate = this.getPageDate();
    var dropMonth = calendarState === 'DROP_MONTH';
    var addPrefix = (0, _utils.prefix)(classPrefix);
    var calendarClasses = (0, _classnames2.default)(classPrefix, className, (_classNames = {}, _classNames[addPrefix('show-month-dropdown')] = dropMonth, _classNames));

    var unhandled = (0, _utils.getUnhandledProps)(Calendar, rest);

    return React.createElement(
      'div',
      _extends({}, unhandled, { className: calendarClasses }),
      React.createElement(_Header2.default, {
        showMonth: true,
        date: pageDate,
        disabledBackward: this.disabledBackward(),
        disabledForword: this.disabledForword(),
        onMoveForword: this.handleMoveForword,
        onMoveBackward: this.handleMoveBackward,
        onToggleMonthDropdown: onToggleMonthDropdown
      }),
      React.createElement(_View2.default, {
        activeDate: pageDate,
        value: value,
        hoverValue: hoverValue,
        onSelect: onSelect,
        onMouseMove: onMouseMove,
        disabledDate: disabledDate,
        isoWeek: isoWeek
      }),
      React.createElement(_MonthDropdown2.default, {
        date: pageDate,
        show: dropMonth,
        disabledMonth: this.disabledMonth,
        onSelect: onChangePageDate,
        limitStartYear: limitStartYear,
        limitEndYear: limitEndYear
      })
    );
  };

  return Calendar;
}(React.Component);

Calendar.defaultProps = {
  calendarDate: [(0, _moment2.default)(), (0, _moment2.default)().add(1, 'month')],
  index: 0
};
Calendar.handledProps = ['calendarDate', 'calendarState', 'className', 'classPrefix', 'disabledDate', 'format', 'hoverValue', 'index', 'isoWeek', 'limitEndYear', 'limitStartYear', 'onChangePageDate', 'onMouseMove', 'onMoveBackward', 'onMoveForword', 'onSelect', 'onToggleMonthDropdown', 'value'];
Calendar.propTypes = {
  disabledDate: _propTypes2.default.func,
  calendarState: _propTypes2.default.oneOf(['DROP_MONTH', 'DROP_TIME']),
  index: _propTypes2.default.number.isRequired,
  calendarDate: _propTypes2.default.arrayOf(function () {
    return (typeof moment$Moment === 'function' ? _propTypes2.default.instanceOf(moment$Moment) : _propTypes2.default.any).apply(this, arguments);
  }).isRequired,
  value: _propTypes2.default.arrayOf(function () {
    return (typeof moment$Moment === 'function' ? _propTypes2.default.instanceOf(moment$Moment) : _propTypes2.default.any).apply(this, arguments);
  }),
  hoverValue: _propTypes2.default.arrayOf(function () {
    return (typeof moment$Moment === 'function' ? _propTypes2.default.instanceOf(moment$Moment) : _propTypes2.default.any).apply(this, arguments);
  }),
  onMoveForword: _propTypes2.default.func,
  onMoveBackward: _propTypes2.default.func,
  onSelect: _propTypes2.default.func,
  onMouseMove: _propTypes2.default.func,
  onToggleMonthDropdown: _propTypes2.default.func,
  onChangePageDate: _propTypes2.default.func,
  format: _propTypes2.default.string.isRequired,
  isoWeek: _propTypes2.default.bool,
  className: _propTypes2.default.string,
  classPrefix: _propTypes2.default.string,
  limitStartYear: _propTypes2.default.number,
  limitEndYear: _propTypes2.default.number
};


var enhance = (0, _utils.defaultProps)({
  classPrefix: 'calendar'
});

exports.default = enhance(Calendar);