'use strict';

exports.__esModule = true;

var _debounce2 = require('lodash/debounce');

var _debounce3 = _interopRequireDefault(_debounce2);

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _utils = require('../../utils');

var _Type = require('../Type');

var _Type2 = _interopRequireDefault(_Type);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defaults(obj, defaults) { var keys = Object.getOwnPropertyNames(defaults); for (var i = 0; i < keys.length; i++) { var key = keys[i]; var value = Object.getOwnPropertyDescriptor(defaults, key); if (value && value.configurable && obj[key] === undefined) { Object.defineProperty(obj, key, value); } } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : _defaults(subClass, superClass); }

var TableRow = function (_React$Component) {
  _inherits(TableRow, _React$Component);

  function TableRow() {
    var _temp, _this, _ret;

    _classCallCheck(this, TableRow);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _React$Component.call.apply(_React$Component, [this].concat(args))), _this), _this.addPrefix = function (name) {
      return (0, _utils.prefix)(_this.props.classPrefix)(name);
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  TableRow.prototype.renderDays = function renderDays() {
    var _props = this.props,
        weekendDate = _props.weekendDate,
        disabledDate = _props.disabledDate,
        inSameMonth = _props.inSameMonth,
        selected = _props.selected,
        hoverValue = _props.hoverValue,
        onSelect = _props.onSelect,
        onMouseMove = _props.onMouseMove;


    var days = [];
    var selectedStartDate = selected[0] ? selected[0].clone() : null;
    var selectedEndDate = selected[1] ? selected[1].clone() : null;
    var hoverStartDate = hoverValue[0] || null;
    var hoverEndDate = hoverValue[1] || null;

    for (var i = 0; i < 7; i += 1) {
      var _classNames;

      var thisDate = (0, _moment2.default)(weekendDate).add(i, 'd');
      var _selectValue = [selectedStartDate, selectedEndDate].sort(function (a, b) {
        return (a ? a.unix() : 0) - (b ? b.unix() : 0);
      });

      var disabled = disabledDate && disabledDate(thisDate.clone(), _selectValue, _Type2.default.CALENDAR);
      var isToday = thisDate.isSame((0, _moment2.default)(), 'date');
      var inRange = false;

      var unSameMonth = !(inSameMonth && inSameMonth(thisDate));

      var isStartSelected = !unSameMonth && selectedStartDate && thisDate.isSame(selectedStartDate, 'date');
      var isEndSelected = !unSameMonth && selectedEndDate && thisDate.isSame(selectedEndDate, 'date');

      var isSelected = isStartSelected || isEndSelected;

      // for Selected
      if (selectedStartDate && selectedEndDate) {
        if (thisDate.isBefore(selectedEndDate, 'date') && thisDate.isAfter(selectedStartDate, 'date')) {
          inRange = true;
        }
        if (thisDate.isBefore(selectedStartDate, 'date') && thisDate.isAfter(selectedEndDate, 'date')) {
          inRange = true;
        }
      }

      // for Hovering
      if (!isSelected && hoverEndDate && hoverStartDate) {
        if (!thisDate.isAfter(hoverEndDate, 'date') && !thisDate.isBefore(hoverStartDate, 'date')) {
          inRange = true;
        }
        if (!thisDate.isAfter(hoverStartDate, 'date') && !thisDate.isBefore(hoverEndDate, 'date')) {
          inRange = true;
        }
      }

      var classes = (0, _classnames2.default)(this.addPrefix('cell'), (_classNames = {}, _classNames[this.addPrefix('cell-un-same-month')] = unSameMonth, _classNames[this.addPrefix('cell-is-today')] = isToday, _classNames[this.addPrefix('cell-selected-start')] = isStartSelected, _classNames[this.addPrefix('cell-selected-end')] = isEndSelected, _classNames[this.addPrefix('cell-selected')] = isSelected, _classNames[this.addPrefix('cell-in-range')] = !unSameMonth && inRange, _classNames[this.addPrefix('cell-disabled')] = disabled, _classNames));

      var title = thisDate.format('YYYY-MM-DD');

      days.push(React.createElement(
        'div',
        {
          className: classes,
          role: 'menu',
          tabIndex: '-1',
          title: isToday ? title + ' (Today)' : title,
          onMouseEnter: !disabled && onMouseMove ? onMouseMove.bind(null, thisDate) : undefined,
          onClick: !disabled && onSelect ? (0, _debounce3.default)(onSelect.bind(null, thisDate), 100) : undefined,
          key: title
        },
        React.createElement(
          'span',
          { className: this.addPrefix('cell-content') },
          thisDate.date()
        )
      ));
    }
    return days;
  };

  TableRow.prototype.render = function render() {
    var _props2 = this.props,
        className = _props2.className,
        rest = _objectWithoutProperties(_props2, ['className']);

    var classes = (0, _classnames2.default)(this.addPrefix('row'), className);
    var unhandled = (0, _utils.getUnhandledProps)(TableRow, rest);

    return React.createElement(
      'div',
      _extends({}, unhandled, { className: classes }),
      this.renderDays()
    );
  };

  return TableRow;
}(React.Component);

TableRow.defaultProps = {
  selected: [],
  hoverValue: []
};
TableRow.handledProps = ['className', 'classPrefix', 'disabledDate', 'hoverValue', 'inSameMonth', 'onMouseMove', 'onSelect', 'selected', 'weekendDate'];
TableRow.propTypes = {
  weekendDate: function weekendDate() {
    return (typeof moment$Moment === 'function' ? _propTypes2.default.instanceOf(moment$Moment) : _propTypes2.default.any).apply(this, arguments);
  },
  selected: _propTypes2.default.arrayOf(function () {
    return (typeof moment$Moment === 'function' ? _propTypes2.default.instanceOf(moment$Moment) : _propTypes2.default.any).apply(this, arguments);
  }).isRequired,
  hoverValue: _propTypes2.default.arrayOf(function () {
    return (typeof moment$Moment === 'function' ? _propTypes2.default.instanceOf(moment$Moment) : _propTypes2.default.any).apply(this, arguments);
  }).isRequired,
  onSelect: _propTypes2.default.func,
  disabledDate: _propTypes2.default.func,
  inSameMonth: _propTypes2.default.func,
  onMouseMove: _propTypes2.default.func,
  className: _propTypes2.default.string,
  classPrefix: _propTypes2.default.string
};


var enhance = (0, _utils.defaultProps)({
  classPrefix: 'calendar-table'
});

exports.default = enhance(TableRow);