'use strict';

exports.__esModule = true;

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _Calendar = require('./Calendar');

var _Calendar2 = _interopRequireDefault(_Calendar);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _defaults(obj, defaults) { var keys = Object.getOwnPropertyNames(defaults); for (var i = 0; i < keys.length; i++) { var key = keys[i]; var value = Object.getOwnPropertyDescriptor(defaults, key); if (value && value.configurable && obj[key] === undefined) { Object.defineProperty(obj, key, value); } } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : _defaults(subClass, superClass); }

var DatePicker = function (_React$Component) {
  _inherits(DatePicker, _React$Component);

  function DatePicker(props) {
    _classCallCheck(this, DatePicker);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _this.onMoveForword = function (nextPageDate) {
      var _this$props = _this.props,
          onChangeCalendarDate = _this$props.onChangeCalendarDate,
          index = _this$props.index;

      onChangeCalendarDate && onChangeCalendarDate(index, nextPageDate);
    };

    _this.onMoveBackward = function (nextPageDate) {
      var _this$props2 = _this.props,
          onChangeCalendarDate = _this$props2.onChangeCalendarDate,
          index = _this$props2.index;

      onChangeCalendarDate && onChangeCalendarDate(index, nextPageDate);
    };

    _this.handleChangePageDate = function (nextPageDate) {
      var _this$props3 = _this.props,
          onChangeCalendarDate = _this$props3.onChangeCalendarDate,
          index = _this$props3.index;

      onChangeCalendarDate && onChangeCalendarDate(index, nextPageDate);
      _this.setState({
        calendarState: undefined
      });
    };

    _this.toggleMonthDropdown = function () {
      var calendarState = _this.state.calendarState;


      if (calendarState === 'DROP_MONTH') {
        _this.hideMonthDropdown();
      } else {
        _this.showMonthDropdown();
      }
    };

    _this.state = {
      calendarState: undefined
    };
    return _this;
  }

  DatePicker.prototype.showMonthDropdown = function showMonthDropdown() {
    this.setState({ calendarState: 'DROP_MONTH' });
  };

  DatePicker.prototype.hideMonthDropdown = function hideMonthDropdown() {
    this.setState({ calendarState: undefined });
  };

  DatePicker.prototype.render = function render() {
    var _props = this.props,
        format = _props.format,
        value = _props.value,
        hoverValue = _props.hoverValue,
        index = _props.index,
        calendarDate = _props.calendarDate,
        onSelect = _props.onSelect,
        onMouseMove = _props.onMouseMove,
        disabledDate = _props.disabledDate,
        isoWeek = _props.isoWeek,
        limitStartYear = _props.limitStartYear,
        limitEndYear = _props.limitEndYear;
    var calendarState = this.state.calendarState;


    return React.createElement(_Calendar2.default, {
      disabledDate: disabledDate,
      format: format,
      value: value,
      isoWeek: isoWeek,
      hoverValue: hoverValue,
      calendarState: calendarState,
      calendarDate: calendarDate,
      index: index,
      onMoveForword: this.onMoveForword,
      onMoveBackward: this.onMoveBackward,
      onSelect: onSelect,
      onMouseMove: onMouseMove,
      onToggleMonthDropdown: this.toggleMonthDropdown,
      onChangePageDate: this.handleChangePageDate,
      limitStartYear: limitStartYear,
      limitEndYear: limitEndYear
    });
  };

  return DatePicker;
}(React.Component);

DatePicker.defaultProps = {
  value: [],
  calendarDate: [(0, _moment2.default)(), (0, _moment2.default)().add(1, 'month')],
  format: 'YYYY-MM-DD',
  index: 0
};
DatePicker.handledProps = ['calendarDate', 'disabledDate', 'format', 'hoverValue', 'index', 'isoWeek', 'limitEndYear', 'limitStartYear', 'onChangeCalendarDate', 'onMouseMove', 'onSelect', 'value'];
DatePicker.propTypes = {
  disabledDate: _propTypes2.default.func,
  value: _propTypes2.default.arrayOf(function () {
    return (typeof moment$Moment === 'function' ? _propTypes2.default.instanceOf(moment$Moment) : _propTypes2.default.any).apply(this, arguments);
  }),
  hoverValue: _propTypes2.default.arrayOf(function () {
    return (typeof moment$Moment === 'function' ? _propTypes2.default.instanceOf(moment$Moment) : _propTypes2.default.any).apply(this, arguments);
  }),
  calendarDate: _propTypes2.default.arrayOf(function () {
    return (typeof moment$Moment === 'function' ? _propTypes2.default.instanceOf(moment$Moment) : _propTypes2.default.any).apply(this, arguments);
  }),
  index: _propTypes2.default.number.isRequired,
  format: _propTypes2.default.string.isRequired,
  onSelect: _propTypes2.default.func,
  onMouseMove: _propTypes2.default.func,
  onChangeCalendarDate: _propTypes2.default.func,
  isoWeek: _propTypes2.default.bool,
  limitStartYear: _propTypes2.default.number,
  limitEndYear: _propTypes2.default.number
};
exports.default = DatePicker;