'use strict';

exports.__esModule = true;

var _kebabCase2 = require('lodash/kebabCase');

var _kebabCase3 = _interopRequireDefault(_kebabCase2);

var _isUndefined2 = require('lodash/isUndefined');

var _isUndefined3 = _interopRequireDefault(_isUndefined2);

var _get2 = require('lodash/get');

var _get3 = _interopRequireDefault(_get2);

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _rsuiteIntl = require('rsuite-intl');

var _OverlayTrigger = require('rsuite-utils/lib/Overlay/OverlayTrigger');

var _OverlayTrigger2 = _interopRequireDefault(_OverlayTrigger);

var _Picker = require('rsuite-utils/lib/Picker');

var _utils = require('../utils');

var _PickerToggle = require('../_picker/PickerToggle');

var _PickerToggle2 = _interopRequireDefault(_PickerToggle);

var _getToggleWrapperClassName = require('../_picker/getToggleWrapperClassName');

var _getToggleWrapperClassName2 = _interopRequireDefault(_getToggleWrapperClassName);

var _Toolbar = require('./Toolbar');

var _Toolbar2 = _interopRequireDefault(_Toolbar);

var _DatePicker = require('./DatePicker');

var _DatePicker2 = _interopRequireDefault(_DatePicker);

var _setTimingMargin = require('./setTimingMargin');

var _setTimingMargin2 = _interopRequireDefault(_setTimingMargin);

var _equalMoment = require('./equalMoment');

var _equalMoment2 = _interopRequireDefault(_equalMoment);

var _Type = require('./Type');

var _Type2 = _interopRequireDefault(_Type);

var _TypeDefinition = require('../utils/TypeDefinition');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defaults(obj, defaults) { var keys = Object.getOwnPropertyNames(defaults); for (var i = 0; i < keys.length; i++) { var key = keys[i]; var value = Object.getOwnPropertyDescriptor(defaults, key); if (value && value.configurable && obj[key] === undefined) { Object.defineProperty(obj, key, value); } } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : _defaults(subClass, superClass); }

function getCalendarDate() {
  var value = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];

  var calendarDate = [(0, _moment2.default)(), (0, _moment2.default)().add(1, 'month')];

  // Update calendarDate if the value is not null
  if (value[0] && value[1]) {
    var isSameMonth = value[0].clone().isSame(value[1], 'month');
    calendarDate = [value[0], isSameMonth ? value[1].clone().add(1, 'month') : value[1].clone()];
  }
  return calendarDate;
}

var DateRangePicker = function (_React$Component) {
  _inherits(DateRangePicker, _React$Component);

  function DateRangePicker(props) {
    _classCallCheck(this, DateRangePicker);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _initialiseProps.call(_this);

    var defaultValue = props.defaultValue,
        value = props.value;

    var activeValue = value || defaultValue || [];
    var calendarDate = getCalendarDate(activeValue);

    _this.state = {
      value: activeValue,
      selectValue: activeValue,
      doneSelected: true,
      calendarDate: calendarDate,
      hoverValue: [],
      currentHoverDate: null
    };
    return _this;
  }

  DateRangePicker.prototype.getDateString = function getDateString(value) {
    var _props = this.props,
        placeholder = _props.placeholder,
        format = _props.format;

    var nextValue = value || this.getValue();
    var startDate = (0, _get3.default)(nextValue, '0');
    var endDate = (0, _get3.default)(nextValue, '1');

    if (startDate && endDate) {
      return startDate.format(format) + ' ~ ' + endDate.format(format);
    }

    return placeholder || format + ' ~ ' + format;
  };

  // hover range presets


  DateRangePicker.prototype.getHoverRange = function getHoverRange(date) {
    var hoverRange = this.props.hoverRange;

    if (!hoverRange) {
      return [];
    }

    var hoverRangeFunc = hoverRange;
    if (hoverRange === 'week') {
      hoverRangeFunc = this.getWeekHoverRange;
    }

    if (hoverRangeFunc === 'month') {
      hoverRangeFunc = this.getMonthHoverRange;
    }

    if (typeof hoverRangeFunc !== 'function') {
      return [];
    }

    var hoverValues = hoverRangeFunc(date.clone());
    var isHoverRangeValid = hoverValues instanceof Array && hoverValues.length === 2;
    if (!isHoverRangeValid) {
      return [];
    }
    if (hoverValues[0].isAfter(hoverValues[1])) {
      hoverValues.reverse();
    }
    return hoverValues;
  };

  DateRangePicker.prototype.open = function open() {
    if (this.trigger) {
      this.trigger.show();
    }
  };

  DateRangePicker.prototype.close = function close() {
    if (this.trigger) {
      this.trigger.hide();
    }
  };

  DateRangePicker.prototype.resetPageDate = function resetPageDate() {
    var selectValue = this.getValue();
    var calendarDate = getCalendarDate(selectValue);
    this.setState({
      selectValue: selectValue,
      calendarDate: calendarDate
    });
  };

  /**
   * Toolbar operation callback function
   */


  DateRangePicker.prototype.updateValue = function updateValue(nextSelectValue) {
    var closeOverlay = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
    var _state = this.state,
        value = _state.value,
        selectValue = _state.selectValue;
    var onChange = this.props.onChange;

    var nextValue = !(0, _isUndefined3.default)(nextSelectValue) ? nextSelectValue : selectValue;

    this.setState({
      selectValue: nextValue || [],
      value: nextValue
    });

    if (onChange && (!(0, _equalMoment2.default)(nextValue[0], value[0]) || !(0, _equalMoment2.default)(nextValue[1], value[1]))) {
      onChange(nextValue);
    }

    // `closeOverlay` default value is `true`
    if (closeOverlay !== false) {
      this.close();
    }
  };

  DateRangePicker.prototype.disabledByBetween = function disabledByBetween(start, end, type) {
    var disabledDate = this.props.disabledDate;
    var _state2 = this.state,
        selectValue = _state2.selectValue,
        doneSelected = _state2.doneSelected;

    var date = start.clone();
    var selectStartDate = selectValue[0] ? selectValue[0].clone() : null;
    var selectEndDate = selectValue[1] ? selectValue[1].clone() : null;
    var nextSelectValue = [selectStartDate, selectEndDate];

    // If the date is between the start and the end
    // the button is disabled
    while (start.isBefore(end) || start.isSame(end, 'day')) {
      if (disabledDate && disabledDate(date, nextSelectValue, doneSelected, type)) {
        return true;
      }
      start.add(1, 'd');
    }

    return false;
  };

  DateRangePicker.prototype.renderDropdownMenu = function renderDropdownMenu() {
    var _this2 = this;

    var _props2 = this.props,
        placement = _props2.placement,
        menuClassName = _props2.menuClassName,
        ranges = _props2.ranges,
        isoWeek = _props2.isoWeek,
        limitStartYear = _props2.limitStartYear,
        limitEndYear = _props2.limitEndYear;
    var _state3 = this.state,
        calendarDate = _state3.calendarDate,
        selectValue = _state3.selectValue,
        hoverValue = _state3.hoverValue,
        doneSelected = _state3.doneSelected;


    var classes = (0, _classnames2.default)(this.addPrefix('daterange-menu'), this.addPrefix('placement-' + (0, _kebabCase3.default)(placement)), menuClassName);

    var pickerProps = {
      isoWeek: isoWeek,
      doneSelected: doneSelected,
      hoverValue: hoverValue,
      calendarDate: calendarDate,
      limitStartYear: limitStartYear,
      limitEndYear: limitEndYear,
      value: selectValue,
      disabledDate: this.handleDisabledDate,
      onSelect: this.handleChangeSelectValue,
      onMouseMove: this.handleMouseMoveSelectValue,
      onChangeCalendarDate: this.handleChangeCalendarDate
    };

    return React.createElement(
      _Picker.MenuWrapper,
      {
        className: classes,
        ref: function ref(_ref) {
          // for test
          _this2.menuContainer = _ref;
        }
      },
      React.createElement(
        'div',
        { className: this.addPrefix('daterange-panel') },
        React.createElement(
          'div',
          { className: this.addPrefix('daterange-content') },
          React.createElement(
            'div',
            { className: this.addPrefix('daterange-header') },
            this.getDateString(selectValue)
          ),
          React.createElement(
            'div',
            { className: this.addPrefix('daterange-calendar-group') },
            React.createElement(_DatePicker2.default, _extends({ index: 0 }, pickerProps)),
            React.createElement(_DatePicker2.default, _extends({ index: 1 }, pickerProps))
          )
        ),
        React.createElement(_Toolbar2.default, {
          ranges: ranges,
          selectValue: selectValue,
          disabledOkButton: this.disabledOkButton,
          disabledShortcutButton: this.disabledShortcutButton,
          onShortcut: this.handleShortcutPageDate,
          onOk: this.handleOK
        })
      )
    );
  };

  DateRangePicker.prototype.render = function render() {
    var _this3 = this;

    var _props3 = this.props,
        className = _props3.className,
        disabled = _props3.disabled,
        ranges = _props3.ranges,
        cleanable = _props3.cleanable,
        isoWeek = _props3.isoWeek,
        locale = _props3.locale,
        open = _props3.open,
        placement = _props3.placement,
        defaultOpen = _props3.defaultOpen,
        classPrefix = _props3.classPrefix,
        toggleComponentClass = _props3.toggleComponentClass,
        block = _props3.block,
        style = _props3.style,
        container = _props3.container,
        containerPadding = _props3.containerPadding,
        onEnter = _props3.onEnter,
        onEntering = _props3.onEntering,
        onEntered = _props3.onEntered,
        onExit = _props3.onExit,
        onExiting = _props3.onExiting,
        onExited = _props3.onExited,
        appearance = _props3.appearance,
        rest = _objectWithoutProperties(_props3, ['className', 'disabled', 'ranges', 'cleanable', 'isoWeek', 'locale', 'open', 'placement', 'defaultOpen', 'classPrefix', 'toggleComponentClass', 'block', 'style', 'container', 'containerPadding', 'onEnter', 'onEntering', 'onEntered', 'onExit', 'onExiting', 'onExited', 'appearance']);

    var value = this.getValue();
    var unhandled = (0, _utils.getUnhandledProps)(DateRangePicker, rest);
    var hasValue = value && value.length > 1;
    var classes = (0, _getToggleWrapperClassName2.default)('daterange', this.addPrefix, this.props, hasValue);

    return React.createElement(
      _rsuiteIntl.IntlProvider,
      { locale: locale },
      React.createElement(
        'div',
        {
          className: classes,
          style: style,
          ref: function ref(_ref3) {
            _this3.container = _ref3;
          }
        },
        React.createElement(
          _OverlayTrigger2.default,
          {
            ref: function ref(_ref2) {
              _this3.trigger = _ref2;
            },
            open: open,
            defaultOpen: defaultOpen,
            disabled: disabled,
            trigger: 'click',
            placement: placement,
            onEnter: onEnter,
            onEntering: onEntering,
            onEntered: (0, _utils.createChainedFunction)(this.handleEntered, onEntered),
            onExit: onExit,
            onExiting: onExiting,
            onExited: (0, _utils.createChainedFunction)(this.handleExited, onExited),
            speaker: this.renderDropdownMenu(),
            container: container,
            containerPadding: containerPadding
          },
          React.createElement(
            _PickerToggle2.default,
            _extends({}, unhandled, {
              componentClass: toggleComponentClass,
              onClean: this.handleClean,
              cleanable: cleanable && !disabled,
              hasValue: hasValue
            }),
            this.getDateString()
          )
        )
      )
    );
  };

  return DateRangePicker;
}(React.Component);

DateRangePicker.defaultProps = {
  appearance: 'default',
  placement: 'bottomLeft',
  limitStartYear: 5,
  limitEndYear: 5,
  format: 'YYYY-MM-DD',
  placeholder: '',
  cleanable: true,
  locale: {
    sunday: 'Su',
    monday: 'Mo',
    tuesday: 'Tu',
    wednesday: 'We',
    thursday: 'Th',
    friday: 'Fr',
    saturday: 'Sa',
    ok: 'OK',
    today: 'Today',
    yesterday: 'Yesterday',
    last7Days: 'Last 7 Days',
    hours: 'Hours',
    minutes: 'Minutes',
    seconds: 'Seconds'
  }
};
DateRangePicker.handledProps = ['appearance', 'block', 'className', 'classPrefix', 'cleanable', 'container', 'containerPadding', 'defaultOpen', 'defaultValue', 'disabled', 'disabledDate', 'format', 'hoverRange', 'isoWeek', 'limitEndYear', 'limitStartYear', 'locale', 'menuClassName', 'onChange', 'onClose', 'onEnter', 'onEntered', 'onEntering', 'onExit', 'onExited', 'onExiting', 'onOk', 'onOpen', 'onSelect', 'oneTap', 'open', 'placeholder', 'placement', 'ranges', 'style', 'toggleComponentClass', 'value'];
DateRangePicker.propTypes = {
  appearance: _propTypes2.default.oneOf(['default', 'subtle']).isRequired,
  disabledDate: _propTypes2.default.func,
  ranges: _propTypes2.default.arrayOf(_propTypes2.default.shape({
    label: _propTypes2.default.node.isRequired,
    closeOverlay: _propTypes2.default.bool,
    value: _propTypes2.default.oneOfType([_propTypes2.default.arrayOf(function () {
      return (typeof moment$Moment === 'function' ? _propTypes2.default.instanceOf(moment$Moment) : _propTypes2.default.any).apply(this, arguments);
    }), _propTypes2.default.func]).isRequired
  })),
  value: _propTypes2.default.arrayOf(function () {
    return (typeof moment$Moment === 'function' ? _propTypes2.default.instanceOf(moment$Moment) : _propTypes2.default.any).apply(this, arguments);
  }),
  defaultValue: _propTypes2.default.arrayOf(function () {
    return (typeof moment$Moment === 'function' ? _propTypes2.default.instanceOf(moment$Moment) : _propTypes2.default.any).apply(this, arguments);
  }),
  placeholder: _propTypes2.default.node,
  format: _propTypes2.default.string.isRequired,
  disabled: _propTypes2.default.bool,
  locale: _propTypes2.default.object,
  onChange: _propTypes2.default.func,
  onOk: _propTypes2.default.func,
  hoverRange: _propTypes2.default.oneOfType([_propTypes2.default.oneOf(['week']), _propTypes2.default.oneOf(['month']), _propTypes2.default.func]),
  cleanable: _propTypes2.default.bool,
  isoWeek: _propTypes2.default.bool,


  /**
   * 单击模式，是否只点选一次就选好值
   * 用于选择单日，或配合 hoverRange 使用
   */
  oneTap: _propTypes2.default.bool,
  limitStartYear: _propTypes2.default.number,
  limitEndYear: _propTypes2.default.number,
  className: _propTypes2.default.string,
  menuClassName: _propTypes2.default.string,
  classPrefix: _propTypes2.default.string,
  container: _propTypes2.default.oneOfType([function () {
    return (typeof HTMLElement === 'function' ? _propTypes2.default.instanceOf(HTMLElement) : _propTypes2.default.any).apply(this, arguments);
  }, _propTypes2.default.func]),
  containerPadding: _propTypes2.default.number,
  block: _propTypes2.default.bool,
  toggleComponentClass: function toggleComponentClass() {
    return (typeof (React.ElementType == null ? {} : React.ElementType) === 'function' ? _propTypes2.default.instanceOf(React.ElementType == null ? {} : React.ElementType) : _propTypes2.default.any).apply(this, arguments);
  },
  style: _propTypes2.default.object,
  open: _propTypes2.default.bool,
  defaultOpen: _propTypes2.default.bool,
  placement: function placement() {
    return (typeof _TypeDefinition.bpfrpt_proptype_Placement === 'function' ? _TypeDefinition.bpfrpt_proptype_Placement : _propTypes2.default.shape(_TypeDefinition.bpfrpt_proptype_Placement)).apply(this, arguments);
  },
  onSelect: _propTypes2.default.func,
  onOpen: _propTypes2.default.func,
  onClose: _propTypes2.default.func,
  onEnter: _propTypes2.default.func,
  onEntering: _propTypes2.default.func,
  onEntered: _propTypes2.default.func,
  onExit: _propTypes2.default.func,
  onExiting: _propTypes2.default.func,
  onExited: _propTypes2.default.func
};

var _initialiseProps = function _initialiseProps() {
  var _this4 = this;

  this.getValue = function () {
    return _this4.props.value || _this4.state.value || [];
  };

  this.getWeekHoverRange = function (date) {
    var isoWeek = _this4.props.isoWeek;


    if (isoWeek) {
      // set to the first day of this week according to ISO 8601, 12:00 am
      return [date.clone().startOf('isoWeek'), date.clone().endOf('isoWeek')];
    }

    return [date.clone().startOf('week'), date.clone().endOf('week')];
  };

  this.getMonthHoverRange = function (date) {
    return [date.clone().startOf('month'), date.clone().endOf('month')];
  };

  this.handleChangeCalendarDate = function (index, date) {
    var calendarDate = _this4.state.calendarDate;

    calendarDate[index] = date;

    _this4.setState({ calendarDate: calendarDate });
  };

  this.handleShortcutPageDate = function (value, closeOverlay) {
    _this4.updateValue(value, closeOverlay);
  };

  this.handleOK = function (event) {
    var onOk = _this4.props.onOk;

    _this4.updateValue();
    onOk && onOk(_this4.state.selectValue, event);
  };

  this.handleChangeSelectValue = function (date) {
    var _state4 = _this4.state,
        selectValue = _state4.selectValue,
        doneSelected = _state4.doneSelected;
    var onSelect = _this4.props.onSelect;

    var nextValue = [];
    var nextHoverValue = _this4.getHoverRange(date);

    if (doneSelected) {
      if (nextHoverValue.length) {
        nextValue = [nextHoverValue[0], nextHoverValue[1], date];
        nextHoverValue = [nextHoverValue[0], nextHoverValue[1], date];
      } else {
        nextValue = [date, undefined, date];
      }
    } else {
      if (nextHoverValue.length) {
        nextValue = [selectValue[0], selectValue[1]];
      } else {
        nextValue = [selectValue[0], date];
      }

      if (nextValue[0].isAfter(nextValue[1])) {
        nextValue.reverse();
      }

      nextValue[0] = (0, _setTimingMargin2.default)(nextValue[0]);
      nextValue[1] = (0, _setTimingMargin2.default)(nextValue[1]);

      _this4.setState({
        calendarDate: getCalendarDate(nextValue)
      });
    }

    var nextState = {
      doneSelected: !doneSelected,
      selectValue: nextValue,
      hoverValue: nextHoverValue
    };

    _this4.setState(nextState, function () {
      // 如果是单击模式，并且是第一次点选，再触发一次点击
      if (_this4.props.oneTap && !_this4.state.doneSelected) {
        _this4.handleChangeSelectValue(date);
      }
      onSelect && onSelect(date);
    });
  };

  this.handleMouseMoveSelectValue = function (date) {
    var _state5 = _this4.state,
        doneSelected = _state5.doneSelected,
        selectValue = _state5.selectValue,
        hoverValue = _state5.hoverValue,
        currentHoverDate = _state5.currentHoverDate;
    var hoverRange = _this4.props.hoverRange;


    if (currentHoverDate && date.isSame(currentHoverDate, 'day')) {
      return;
    }

    var nextHoverValue = _this4.getHoverRange(date);

    if (doneSelected && !(0, _isUndefined3.default)(hoverRange)) {
      _this4.setState({
        currentHoverDate: date,
        hoverValue: nextHoverValue
      });
      return;
    } else if (doneSelected) {
      return;
    }

    var nextValue = selectValue;

    if (!nextHoverValue.length) {
      nextValue[1] = date;
    } else if (hoverValue) {
      nextValue = [nextHoverValue[0].isBefore(hoverValue[0]) ? nextHoverValue[0] : hoverValue[0], nextHoverValue[1].isAfter(hoverValue[1]) ? nextHoverValue[1] : hoverValue[1], nextValue[2]];
    }

    // If `nextValue[0]` is greater than `nextValue[1]` then reverse order
    if (nextValue[0].isAfter(nextValue[1])) {
      nextValue.reverse();
    }

    _this4.setState({
      currentHoverDate: date,
      selectValue: nextValue
    });
  };

  this.handleClean = function () {
    _this4.setState({ calendarDate: [(0, _moment2.default)(), (0, _moment2.default)().add(1, 'month')] });
    _this4.updateValue([]);
  };

  this.handleEntered = function () {
    var onOpen = _this4.props.onOpen;

    onOpen && onOpen();
  };

  this.handleExited = function () {
    var onClose = _this4.props.onClose;

    onClose && onClose();
  };

  this.disabledOkButton = function () {
    var _state6 = _this4.state,
        selectValue = _state6.selectValue,
        doneSelected = _state6.doneSelected;


    if (!selectValue[0] || !selectValue[1] || !doneSelected) {
      return true;
    }

    return _this4.disabledByBetween(selectValue[0].clone(), selectValue[1].clone(), _Type2.default.TOOLBAR_BUTTON_OK);
  };

  this.disabledShortcutButton = function () {
    var value = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];

    if (!value[0] || !value[1]) {
      return true;
    }
    return _this4.disabledByBetween(value[0].clone(), value[1].clone(), _Type2.default.TOOLBAR_SHORTCUT);
  };

  this.handleDisabledDate = function (date, values, type) {
    var disabledDate = _this4.props.disabledDate;
    var doneSelected = _this4.state.doneSelected;

    if (disabledDate) {
      return disabledDate(date, values, doneSelected, type);
    }
    return false;
  };

  this.addPrefix = function (name) {
    return (0, _utils.prefix)(_this4.props.classPrefix)(name);
  };

  this.trigger = null;
  this.menuContainer = null;
  this.container = null;
};

var enhance = (0, _utils.defaultProps)({
  classPrefix: 'picker'
});

exports.default = enhance(DateRangePicker);