'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Button = require('./Button');

var _Button2 = _interopRequireDefault(_Button);

var _Icon = require('./Icon');

var _Icon2 = _interopRequireDefault(_Icon);

var _utils = require('./utils');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _defaults(obj, defaults) { var keys = Object.getOwnPropertyNames(defaults); for (var i = 0; i < keys.length; i++) { var key = keys[i]; var value = Object.getOwnPropertyDescriptor(defaults, key); if (value && value.configurable && obj[key] === undefined) { Object.defineProperty(obj, key, value); } } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : _defaults(subClass, superClass); }

var DorpdownToggle = function (_React$Component) {
  _inherits(DorpdownToggle, _React$Component);

  function DorpdownToggle() {
    _classCallCheck(this, DorpdownToggle);

    return _possibleConstructorReturn(this, _React$Component.apply(this, arguments));
  }

  DorpdownToggle.prototype.render = function render() {
    var _props = this.props,
        className = _props.className,
        classPrefix = _props.classPrefix,
        renderTitle = _props.renderTitle,
        children = _props.children,
        icon = _props.icon,
        noCaret = _props.noCaret,
        Component = _props.componentClass,
        props = _objectWithoutProperties(_props, ['className', 'classPrefix', 'renderTitle', 'children', 'icon', 'noCaret', 'componentClass']);

    var addPrefix = (0, _utils.prefix)(classPrefix);

    if (renderTitle) {
      return React.createElement(
        'span',
        _extends({}, props, { className: (0, _classnames2.default)(classPrefix, addPrefix('custom-title'), className) }),
        renderTitle(children)
      );
    }

    var buttonProps = {};
    if (Component === _Button2.default) {
      buttonProps = {
        componentClass: 'a',
        appearance: 'subtle'
      };
    }

    return React.createElement(
      Component,
      _extends({}, buttonProps, props, { className: (0, _classnames2.default)(classPrefix, className) }),
      icon,
      children,
      noCaret ? null : React.createElement('span', { className: addPrefix('caret') })
    );
  };

  return DorpdownToggle;
}(React.Component);

DorpdownToggle.handledProps = ['children', 'className', 'classPrefix', 'componentClass', 'icon', 'noCaret', 'renderTitle'];
DorpdownToggle.propTypes = {
  className: _propTypes2.default.string,
  children: _propTypes2.default.node,
  icon: _propTypes2.default.node,
  renderTitle: _propTypes2.default.func,
  classPrefix: _propTypes2.default.string,
  noCaret: _propTypes2.default.bool,
  componentClass: function componentClass() {
    return (typeof (React.ElementType == null ? {} : React.ElementType) === 'function' ? _propTypes2.default.instanceOf(React.ElementType == null ? {} : React.ElementType).isRequired : _propTypes2.default.any.isRequired).apply(this, arguments);
  }
};
exports.default = (0, _utils.defaultProps)({
  componentClass: _Button2.default,
  classPrefix: 'dropdown-toggle'
})(DorpdownToggle);