'use strict';

exports.__esModule = true;

var _pick2 = require('lodash/pick');

var _pick3 = _interopRequireDefault(_pick2);

var _kebabCase2 = require('lodash/kebabCase');

var _kebabCase3 = _interopRequireDefault(_kebabCase2);

var _remove2 = require('lodash/remove');

var _remove3 = _interopRequireDefault(_remove2);

var _trim2 = require('lodash/trim');

var _trim3 = _interopRequireDefault(_trim2);

var _get2 = require('lodash/get');

var _get3 = _interopRequireDefault(_get2);

var _clone2 = require('lodash/clone');

var _clone3 = _interopRequireDefault(_clone2);

var _isUndefined2 = require('lodash/isUndefined');

var _isUndefined3 = _interopRequireDefault(_isUndefined2);

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _OverlayTrigger = require('rsuite-utils/lib/Overlay/OverlayTrigger');

var _OverlayTrigger2 = _interopRequireDefault(_OverlayTrigger);

var _Picker = require('rsuite-utils/lib/Picker');

var _reactInputAutosize = require('react-input-autosize');

var _reactInputAutosize2 = _interopRequireDefault(_reactInputAutosize);

var _domLib = require('dom-lib');

var _utils = require('rsuite-utils/lib/utils');

var _utils2 = require('../utils');

var _DropdownMenu = require('../_picker/DropdownMenu');

var _DropdownMenu2 = _interopRequireDefault(_DropdownMenu);

var _DropdownMenuItem = require('../_picker/DropdownMenuItem');

var _DropdownMenuItem2 = _interopRequireDefault(_DropdownMenuItem);

var _DropdownMenuCheckItem = require('../_picker/DropdownMenuCheckItem');

var _DropdownMenuCheckItem2 = _interopRequireDefault(_DropdownMenuCheckItem);

var _getToggleWrapperClassName = require('../_picker/getToggleWrapperClassName');

var _getToggleWrapperClassName2 = _interopRequireDefault(_getToggleWrapperClassName);

var _onMenuKeyDown = require('../_picker/onMenuKeyDown');

var _onMenuKeyDown2 = _interopRequireDefault(_onMenuKeyDown);

var _PickerToggle = require('../_picker/PickerToggle');

var _PickerToggle2 = _interopRequireDefault(_PickerToggle);

var _InputSearch = require('./InputSearch');

var _InputSearch2 = _interopRequireDefault(_InputSearch);

var _Tag = require('../Tag');

var _Tag2 = _interopRequireDefault(_Tag);

var _TypeDefinition = require('../utils/TypeDefinition');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defaults(obj, defaults) { var keys = Object.getOwnPropertyNames(defaults); for (var i = 0; i < keys.length; i++) { var key = keys[i]; var value = Object.getOwnPropertyDescriptor(defaults, key); if (value && value.configurable && obj[key] === undefined) { Object.defineProperty(obj, key, value); } } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : _defaults(subClass, superClass); }

var Dropdown = function (_React$Component) {
  _inherits(Dropdown, _React$Component);

  function Dropdown(props) {
    _classCallCheck(this, Dropdown);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _initialiseProps.call(_this);

    var defaultValue = props.defaultValue,
        groupBy = props.groupBy,
        valueKey = props.valueKey,
        labelKey = props.labelKey,
        defaultOpen = props.defaultOpen,
        multi = props.multi;

    var value = multi ? defaultValue || [] : defaultValue;
    var focusItemValue = multi ? value[0] : defaultValue;

    _this.state = {
      value: value,
      focusItemValue: focusItemValue,
      searchKeyword: '',
      newData: [],
      open: defaultOpen,
      maxWidth: 100
    };

    if (groupBy === valueKey || groupBy === labelKey) {
      throw Error('`groupBy` can not be equal to `valueKey` and `labelKey`');
    }
    return _this;
  }

  Dropdown.prototype.componentDidMount = function componentDidMount() {
    if (this.toggleWrapper) {
      var _maxWidth = (0, _domLib.getWidth)(this.toggleWrapper);
      this.setState({ maxWidth: _maxWidth });
    }
  };

  Dropdown.prototype.getValue = function getValue() {
    var _props = this.props,
        value = _props.value,
        multi = _props.multi;

    var nextValue = (0, _isUndefined3.default)(value) ? this.state.value : value;

    if (multi) {
      return (0, _clone3.default)(nextValue) || [];
    }
    return nextValue;
  };

  Dropdown.prototype.getAllData = function getAllData() {
    var data = this.props.data;
    var newData = this.state.newData;

    return [].concat(data, newData);
  };

  Dropdown.prototype.getAllDataAndCache = function getAllDataAndCache() {
    var cacheData = this.props.cacheData;

    var data = this.getAllData();
    return [].concat(data, cacheData);
  };

  Dropdown.prototype.getLabelByValue = function getLabelByValue(value) {
    var _props2 = this.props,
        renderValue = _props2.renderValue,
        placeholder = _props2.placeholder,
        valueKey = _props2.valueKey,
        labelKey = _props2.labelKey;
    // Find active `MenuItem` by `value`

    var activeItem = (0, _utils.findNodeOfTree)(this.getAllDataAndCache(), function (item) {
      return (0, _utils.shallowEqual)(item[valueKey], value);
    });
    var displayElement = placeholder;

    if ((0, _get3.default)(activeItem, labelKey)) {
      displayElement = (0, _get3.default)(activeItem, labelKey);

      if (renderValue) {
        displayElement = renderValue(value, activeItem);
      }
    }

    return {
      isValid: !!activeItem,
      displayElement: displayElement
    };
  };

  Dropdown.prototype.createOption = function createOption(value) {
    var _ref2;

    var _props3 = this.props,
        valueKey = _props3.valueKey,
        labelKey = _props3.labelKey,
        groupBy = _props3.groupBy,
        locale = _props3.locale;

    if (groupBy) {
      var _ref;

      return _ref = {
        create: true
      }, _ref[groupBy] = locale.newItem, _ref[valueKey] = value, _ref[labelKey] = value, _ref;
    }

    return _ref2 = {
      create: true
    }, _ref2[valueKey] = value, _ref2[labelKey] = value, _ref2;
  };

  Dropdown.prototype.focusInput = function focusInput() {
    if (!this.input) return;
    this.input.focus();
  };

  Dropdown.prototype.blurInput = function blurInput() {
    if (!this.input) return;
    this.input.blur();
  };

  /**
   * Index of keyword  in `label`
   * @param {node} label
   */
  Dropdown.prototype.shouldDisplay = function shouldDisplay(label, searchKeyword) {
    var word = typeof searchKeyword === 'undefined' ? this.state.searchKeyword : searchKeyword;
    if (!(0, _trim3.default)(word)) {
      return true;
    }

    var keyword = word.toLocaleLowerCase();

    if (typeof label === 'string' || typeof label === 'number') {
      return ('' + label).toLocaleLowerCase().indexOf(keyword) >= 0;
    } else if (React.isValidElement(label)) {
      var nodes = (0, _utils.reactToString)(label);
      return nodes.join('').toLocaleLowerCase().indexOf(keyword) >= 0;
    }

    return false;
  };

  Dropdown.prototype.findNode = function findNode(focus) {
    var items = this.getFocusableMenuItems();
    var valueKey = this.props.valueKey;
    var focusItemValue = this.state.focusItemValue;


    for (var i = 0; i < items.length; i += 1) {
      if ((0, _utils.shallowEqual)(focusItemValue, items[i][valueKey])) {
        focus(items, i);
        return;
      }
    }

    focus(items, -1);
  };

  Dropdown.prototype.updatePosition = function updatePosition() {
    if (this.position) {
      this.position.updatePosition(true);
    }
  };

  Dropdown.prototype.renderDropdownMenu = function renderDropdownMenu() {
    var _this2 = this;

    var _props4 = this.props,
        labelKey = _props4.labelKey,
        groupBy = _props4.groupBy,
        placement = _props4.placement,
        locale = _props4.locale,
        renderMenu = _props4.renderMenu,
        renderExtraFooter = _props4.renderExtraFooter,
        menuClassName = _props4.menuClassName,
        menuStyle = _props4.menuStyle,
        creatable = _props4.creatable,
        valueKey = _props4.valueKey,
        multi = _props4.multi;
    var _state = this.state,
        focusItemValue = _state.focusItemValue,
        searchKeyword = _state.searchKeyword;

    var menuClassPrefix = this.addPrefix(multi ? 'check-menu' : 'select-menu');
    var classes = (0, _classnames2.default)(menuClassPrefix, menuClassName, this.addPrefix('placement-' + (0, _kebabCase3.default)(placement)));

    var allData = this.getAllData();

    var filteredData = (0, _utils.filterNodesOfTree)(allData, function (item) {
      return _this2.shouldDisplay(item[labelKey]);
    });

    if (creatable && searchKeyword && !(0, _utils.findNodeOfTree)(allData, function (item) {
      return item[valueKey] === searchKeyword;
    })) {
      filteredData = [].concat(filteredData, [this.createOption(searchKeyword)]);
    }

    // Create a tree structure data when set `groupBy`
    if (groupBy) {
      filteredData = (0, _utils2.getDataGroupBy)(filteredData, groupBy);
    }

    var menuProps = (0, _pick3.default)(this.props, _DropdownMenu2.default.handledProps.filter(function (name) {
      return !['className', 'style', 'classPrefix'].some(function (item) {
        return item === name;
      });
    }));

    var value = this.getValue();
    var menu = filteredData.length ? React.createElement(_DropdownMenu2.default, _extends({}, menuProps, {
      classPrefix: menuClassPrefix,
      dropdownMenuItemClassPrefix: menuClassPrefix + '-item',
      dropdownMenuItemComponentClass: multi ? _DropdownMenuCheckItem2.default : _DropdownMenuItem2.default,
      ref: this.bindMenuContainerRef,
      activeItemValues: multi ? value : [value],
      focusItemValue: focusItemValue,
      data: filteredData,
      group: !(0, _isUndefined3.default)(groupBy),
      onSelect: multi ? this.handleCheckItemSelect : this.handleItemSelect,
      renderMenuItem: this.renderMenuItem
    })) : React.createElement(
      'div',
      { className: this.addPrefix('none') },
      locale.noResultsText
    );

    return React.createElement(
      _Picker.MenuWrapper,
      { className: classes, style: menuStyle, onKeyDown: this.handleKeyDown },
      renderMenu ? renderMenu(menu) : menu,
      renderExtraFooter && renderExtraFooter()
    );
  };

  Dropdown.prototype.renderSingleValue = function renderSingleValue() {
    var value = this.getValue();
    return this.getLabelByValue(value);
  };

  Dropdown.prototype.renderMultiValue = function renderMultiValue() {
    var _this3 = this;

    var _props5 = this.props,
        multi = _props5.multi,
        disabled = _props5.disabled;

    if (!multi) {
      return null;
    }

    var tags = this.getValue() || [];
    return tags.map(function (tag) {
      var _getLabelByValue = _this3.getLabelByValue(tag),
          isValid = _getLabelByValue.isValid,
          displayElement = _getLabelByValue.displayElement;

      if (!isValid) {
        return null;
      }
      return React.createElement(
        _Tag2.default,
        {
          key: tag,
          closable: !disabled,
          title: typeof displayElement === 'string' ? displayElement : undefined,
          onClose: _this3.handleRemoveItemByTag.bind(_this3, tag)
        },
        displayElement
      );
    }).filter(function (item) {
      return item !== null;
    });
  };

  Dropdown.prototype.renderInputSearch = function renderInputSearch() {
    var multi = this.props.multi;

    var props = {
      componentClass: 'input'
    };

    if (multi) {
      props.componentClass = _reactInputAutosize2.default;
      // 52 = 55 (right padding)  - 2 (border) - 6 (left padding)
      props.inputStyle = { maxWidth: this.state.maxWidth - 63 };
    }

    return React.createElement(_InputSearch2.default, _extends({}, props, {
      inputRef: this.bindInputRef,
      onChange: this.handleSearch,
      value: this.state.open ? this.state.searchKeyword : ''
    }));
  };

  Dropdown.prototype.render = function render() {
    var _getToggleWrapperClas;

    var _props6 = this.props,
        data = _props6.data,
        className = _props6.className,
        disabled = _props6.disabled,
        cleanable = _props6.cleanable,
        locale = _props6.locale,
        classPrefix = _props6.classPrefix,
        onOpen = _props6.onOpen,
        onClose = _props6.onClose,
        placement = _props6.placement,
        open = _props6.open,
        defaultOpen = _props6.defaultOpen,
        toggleComponentClass = _props6.toggleComponentClass,
        block = _props6.block,
        style = _props6.style,
        container = _props6.container,
        containerPadding = _props6.containerPadding,
        onEnter = _props6.onEnter,
        onEntering = _props6.onEntering,
        onEntered = _props6.onEntered,
        onExit = _props6.onExit,
        onExiting = _props6.onExiting,
        onExited = _props6.onExited,
        searchable = _props6.searchable,
        multi = _props6.multi,
        rest = _objectWithoutProperties(_props6, ['data', 'className', 'disabled', 'cleanable', 'locale', 'classPrefix', 'onOpen', 'onClose', 'placement', 'open', 'defaultOpen', 'toggleComponentClass', 'block', 'style', 'container', 'containerPadding', 'onEnter', 'onEntering', 'onEntered', 'onExit', 'onExiting', 'onExited', 'searchable', 'multi']);

    var unhandled = (0, _utils2.getUnhandledProps)(Dropdown, rest);

    var _renderSingleValue = this.renderSingleValue(),
        isValid = _renderSingleValue.isValid,
        displayElement = _renderSingleValue.displayElement;

    var tagElements = this.renderMultiValue();
    var hasValue = multi ? !!(0, _get3.default)(tagElements, 'length') : isValid;

    var classes = (0, _getToggleWrapperClassName2.default)('input', this.addPrefix, this.props, hasValue, (_getToggleWrapperClas = {}, _getToggleWrapperClas[this.addPrefix('tag')] = multi, _getToggleWrapperClas[this.addPrefix('focused')] = this.state.open, _getToggleWrapperClas));

    var searching = !!this.state.searchKeyword && this.state.open;
    var displaySearchInput = searchable && !disabled;

    return React.createElement(
      _OverlayTrigger2.default,
      {
        ref: this.bindTriggerRef,
        open: open,
        defaultOpen: defaultOpen,
        disabled: disabled,
        trigger: 'active',
        placement: placement,
        onEnter: (0, _utils2.createChainedFunction)(this.handleEnter, onEnter),
        onEntered: (0, _utils2.createChainedFunction)(this.handleEntered, onEntered),
        onEntering: onEntering,
        onExit: (0, _utils2.createChainedFunction)(this.handleExit, onExit),
        onExited: (0, _utils2.createChainedFunction)(this.handleExited, onExited),
        onExiting: onExiting,
        speaker: this.renderDropdownMenu(),
        container: container,
        containerPadding: containerPadding,
        positionRef: this.bindPositionRef
      },
      React.createElement(
        'div',
        {
          className: classes,
          style: style,
          onKeyDown: this.handleKeyDown,
          onClick: this.handleClick,
          tabIndex: -1,
          role: 'menu',
          ref: this.bindToggleWrapperRef
        },
        React.createElement(
          _PickerToggle2.default,
          _extends({}, unhandled, {
            componentClass: toggleComponentClass,
            onClean: this.handleClean,
            cleanable: cleanable && !disabled,
            hasValue: hasValue
          }),
          searching || multi && hasValue ? null : displayElement || locale.placeholder
        ),
        React.createElement(
          'div',
          { className: this.addPrefix('tag-wrapper') },
          tagElements,
          displaySearchInput && this.renderInputSearch()
        )
      )
    );
  };

  return Dropdown;
}(React.Component);

Dropdown.defaultProps = {
  data: [],
  cacheData: [],
  disabledItemValues: [],
  maxHeight: 320,
  valueKey: 'value',
  labelKey: 'label',
  locale: {
    placeholder: 'Select',
    noResultsText: 'No results found',
    newItem: 'New item',
    createOption: 'Create option "{0}"'
  },
  searchable: true,
  cleanable: true,
  placement: 'bottomLeft'
};
Dropdown.handledProps = ['block', 'cacheData', 'className', 'classPrefix', 'cleanable', 'container', 'containerPadding', 'creatable', 'data', 'defaultOpen', 'defaultValue', 'disabled', 'disabledItemValues', 'groupBy', 'labelKey', 'locale', 'maxHeight', 'menuClassName', 'menuStyle', 'multi', 'onChange', 'onClose', 'onEnter', 'onEntered', 'onEntering', 'onExit', 'onExited', 'onExiting', 'onGroupTitleClick', 'onOpen', 'onSearch', 'onSelect', 'open', 'placeholder', 'placement', 'renderExtraFooter', 'renderMenu', 'renderMenuGroup', 'renderMenuItem', 'renderValue', 'searchable', 'style', 'toggleComponentClass', 'value', 'valueKey'];
Dropdown.propTypes = {
  data: _propTypes2.default.arrayOf(_propTypes2.default.any).isRequired,
  cacheData: _propTypes2.default.arrayOf(_propTypes2.default.any),
  locale: _propTypes2.default.object.isRequired,
  classPrefix: _propTypes2.default.string,
  className: _propTypes2.default.string,
  container: _propTypes2.default.oneOfType([function () {
    return (typeof HTMLElement === 'function' ? _propTypes2.default.instanceOf(HTMLElement) : _propTypes2.default.any).apply(this, arguments);
  }, _propTypes2.default.func]),
  containerPadding: _propTypes2.default.number,
  block: _propTypes2.default.bool,
  toggleComponentClass: function toggleComponentClass() {
    return (typeof (React.ElementType == null ? {} : React.ElementType) === 'function' ? _propTypes2.default.instanceOf(React.ElementType == null ? {} : React.ElementType) : _propTypes2.default.any).apply(this, arguments);
  },
  menuClassName: _propTypes2.default.string,
  menuStyle: _propTypes2.default.object,
  disabled: _propTypes2.default.bool,
  disabledItemValues: _propTypes2.default.arrayOf(_propTypes2.default.any),
  maxHeight: _propTypes2.default.number,
  valueKey: _propTypes2.default.string.isRequired,
  labelKey: _propTypes2.default.string.isRequired,
  value: _propTypes2.default.oneOfType([_propTypes2.default.any, _propTypes2.default.arrayOf(_propTypes2.default.any)]),
  defaultValue: _propTypes2.default.oneOfType([_propTypes2.default.any, _propTypes2.default.arrayOf(_propTypes2.default.any)]),
  renderMenu: _propTypes2.default.func,
  renderMenuItem: _propTypes2.default.func,
  renderMenuGroup: _propTypes2.default.func,
  renderValue: _propTypes2.default.func,
  renderExtraFooter: _propTypes2.default.func,
  onChange: _propTypes2.default.func,
  onSelect: _propTypes2.default.func,
  onGroupTitleClick: _propTypes2.default.func,
  onSearch: _propTypes2.default.func,
  onOpen: _propTypes2.default.func,
  onClose: _propTypes2.default.func,
  onEnter: _propTypes2.default.func,
  onEntering: _propTypes2.default.func,
  onEntered: _propTypes2.default.func,
  onExit: _propTypes2.default.func,
  onExiting: _propTypes2.default.func,
  onExited: _propTypes2.default.func,

  /**
   * group by key in `data`
   */
  groupBy: _propTypes2.default.any,
  placeholder: _propTypes2.default.node,
  searchable: _propTypes2.default.bool,
  cleanable: _propTypes2.default.bool,
  open: _propTypes2.default.bool,
  defaultOpen: _propTypes2.default.bool,
  placement: function placement() {
    return (typeof _TypeDefinition.bpfrpt_proptype_Placement === 'function' ? _TypeDefinition.bpfrpt_proptype_Placement : _propTypes2.default.shape(_TypeDefinition.bpfrpt_proptype_Placement)).apply(this, arguments);
  },
  style: _propTypes2.default.object,
  creatable: _propTypes2.default.bool,
  multi: _propTypes2.default.bool
};

var _initialiseProps = function _initialiseProps() {
  var _this4 = this;

  this.getFocusableMenuItems = function () {
    var labelKey = _this4.props.labelKey;
    var menuItems = _this4.menuContainer.menuItems;

    if (!menuItems) {
      return [];
    }

    var items = Object.values(menuItems).map(function (item) {
      return item.props.getItemData();
    });
    return (0, _utils.filterNodesOfTree)(items, function (item) {
      return _this4.shouldDisplay(item[labelKey]);
    });
  };

  this.menuContainer = {
    menuItems: null
  };

  this.bindMenuContainerRef = function (ref) {
    _this4.menuContainer = ref;
  };

  this.input = null;

  this.bindInputRef = function (ref) {
    _this4.input = ref;
  };

  this.trigger = null;

  this.bindTriggerRef = function (ref) {
    _this4.trigger = ref;
  };

  this.toggleWrapper = null;

  this.bindToggleWrapperRef = function (ref) {
    _this4.toggleWrapper = ref;
  };

  this.position = null;

  this.bindPositionRef = function (ref) {
    _this4.position = ref;
  };

  this.focusNextMenuItem = function () {
    var valueKey = _this4.props.valueKey;

    _this4.findNode(function (items, index) {
      var focusItem = items[index + 1];
      if (!(0, _isUndefined3.default)(focusItem)) {
        _this4.setState({ focusItemValue: focusItem[valueKey] });
      }
    });
  };

  this.focusPrevMenuItem = function () {
    var valueKey = _this4.props.valueKey;

    _this4.findNode(function (items, index) {
      var focusItem = items[index - 1];
      if (!(0, _isUndefined3.default)(focusItem)) {
        _this4.setState({ focusItemValue: focusItem[valueKey] });
      }
    });
  };

  this.handleKeyDown = function (event) {
    if (!_this4.menuContainer) {
      return;
    }

    var multi = _this4.props.multi;


    (0, _onMenuKeyDown2.default)(event, {
      down: _this4.focusNextMenuItem,
      up: _this4.focusPrevMenuItem,
      enter: multi ? _this4.selectFocusMenuCheckItem : _this4.selectFocusMenuItem,
      esc: _this4.closeDropdown,
      del: multi ? _this4.removeLastItem : null
    });
  };

  this.handleClick = function (event) {
    _this4.focusInput();
  };

  this.selectFocusMenuItem = function (event) {
    var _state2 = _this4.state,
        focusItemValue = _state2.focusItemValue,
        searchKeyword = _state2.searchKeyword;
    var valueKey = _this4.props.valueKey;

    if (!focusItemValue) {
      return;
    }

    // Find active `MenuItem` by `value`
    var focusItem = (0, _utils.findNodeOfTree)(_this4.getAllData(), function (item) {
      return (0, _utils.shallowEqual)(item[valueKey], focusItemValue);
    });

    if (!focusItem && focusItemValue === searchKeyword) {
      focusItem = _this4.createOption(searchKeyword);
    }

    _this4.setState({ value: focusItemValue });
    _this4.handleSelect(focusItemValue, focusItem, event);
    _this4.handleChange(focusItemValue, event);
    _this4.closeDropdown();
  };

  this.selectFocusMenuCheckItem = function (event) {
    var valueKey = _this4.props.valueKey;
    var focusItemValue = _this4.state.focusItemValue;

    var value = _this4.getValue();
    var data = _this4.getAllData();

    if (!focusItemValue) {
      return;
    }

    if (!value.some(function (v) {
      return (0, _utils.shallowEqual)(v, focusItemValue);
    })) {
      value.push(focusItemValue);
    } else {
      (0, _remove3.default)(value, function (itemVal) {
        return (0, _utils.shallowEqual)(itemVal, focusItemValue);
      });
    }

    var focusItem = data.find(function (item) {
      return (0, _utils.shallowEqual)((0, _get3.default)(item, valueKey), focusItemValue);
    });

    if (!focusItem) {
      focusItem = _this4.createOption(focusItemValue);
    }

    _this4.setState({ value: value, searchKeyword: '' }, _this4.updatePosition);
    _this4.handleSelect(value, focusItem, event);
    _this4.handleChange(value, event);
  };

  this.handleItemSelect = function (value, item, event) {
    var nextState = {
      value: value,
      focusItemValue: value
    };
    _this4.setState(nextState);
    _this4.handleSelect(value, item, event);
    _this4.handleChange(value, event);
    _this4.closeDropdown();
  };

  this.handleCheckItemSelect = function (nextItemValue, item, event, checked) {
    var value = _this4.getValue();

    if (checked) {
      value.push(nextItemValue);
    } else {
      (0, _remove3.default)(value, function (itemVal) {
        return (0, _utils.shallowEqual)(itemVal, nextItemValue);
      });
    }

    var nextState = {
      value: value,
      searchKeyword: '',
      focusItemValue: nextItemValue
    };

    _this4.setState(nextState, _this4.updatePosition);
    _this4.handleSelect(value, item, event);
    _this4.handleChange(value, event);
  };

  this.handleSelect = function (value, item, event) {
    var _props7 = _this4.props,
        onSelect = _props7.onSelect,
        creatable = _props7.creatable;
    var newData = _this4.state.newData;


    onSelect && onSelect(value, item, event);

    if (creatable && item.create) {
      delete item.create;
      _this4.setState({
        newData: newData.concat(item)
      });
    }
  };

  this.handleSearch = function (searchKeyword, event) {
    var _props8 = _this4.props,
        onSearch = _props8.onSearch,
        labelKey = _props8.labelKey,
        valueKey = _props8.valueKey;

    var filteredData = (0, _utils.filterNodesOfTree)(_this4.getAllData(), function (item) {
      return _this4.shouldDisplay(item[labelKey], searchKeyword);
    });
    var nextState = {
      searchKeyword: searchKeyword,
      focusItemValue: filteredData.length ? filteredData[0][valueKey] : searchKeyword
    };

    _this4.setState(nextState, _this4.updatePosition);

    onSearch && onSearch(searchKeyword, event);
  };

  this.closeDropdown = function () {
    if (_this4.trigger) {
      _this4.trigger.hide();
    }
  };

  this.handleChange = function (value, event) {
    var onChange = _this4.props.onChange;

    onChange && onChange(value, event);
  };

  this.handleClean = function (event) {
    var disabled = _this4.props.disabled;

    if (disabled) {
      return;
    }
    var nextState = {
      value: null,
      focusItemValue: null,
      searchKeyword: ''
    };

    _this4.setState(nextState, function () {
      _this4.handleChange(null, event);
      _this4.updatePosition();
    });
  };

  this.handleEntered = function () {
    var onOpen = _this4.props.onOpen;

    onOpen && onOpen();
  };

  this.handleExited = function () {
    var _props9 = _this4.props,
        onClose = _props9.onClose,
        multi = _props9.multi;

    onClose && onClose();

    var nextState = {
      focusItemValue: null
    };

    if (multi) {
      nextState.searchKeyword = '';
    }

    _this4.setState(nextState);
  };

  this.handleEnter = function () {
    _this4.focusInput();
    _this4.setState({ open: true });
  };

  this.handleExit = function () {
    _this4.blurInput();
    _this4.setState({ open: false });
  };

  this.handleRemoveItemByTag = function (tag, event) {
    event.stopPropagation();
    var value = _this4.getValue();
    (0, _remove3.default)(value, function (itemVal) {
      return (0, _utils.shallowEqual)(itemVal, tag);
    });
    _this4.setState({ value: value }, _this4.updatePosition);
    _this4.handleChange(value, event);
  };

  this.removeLastItem = function (event) {
    var tagName = (0, _get3.default)(event, 'target.tagName');
    if (tagName !== 'INPUT') {
      _this4.focusInput();
      return;
    }
    if (tagName === 'INPUT' && event.target.value) {
      return;
    }
    var value = _this4.getValue();
    value.pop();
    _this4.setState({ value: value }, _this4.updatePosition);
    _this4.handleChange(value, event);
  };

  this.addPrefix = function (name) {
    return (0, _utils2.prefix)(_this4.props.classPrefix)(name);
  };

  this.renderMenuItem = function (label, item) {
    var _props10 = _this4.props,
        locale = _props10.locale,
        renderMenuItem = _props10.renderMenuItem;

    var newLabel = item.create ? React.createElement(
      'span',
      null,
      (0, _utils2.tplTransform)(locale.createOption, label)
    ) : label;
    return renderMenuItem ? renderMenuItem(newLabel, item) : newLabel;
  };
};

var enhance = (0, _utils2.defaultProps)({
  classPrefix: 'picker'
});

exports.default = enhance(Dropdown);