'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _domLib = require('dom-lib');

var _utils = require('../utils');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _defaults(obj, defaults) { var keys = Object.getOwnPropertyNames(defaults); for (var i = 0; i < keys.length; i++) { var key = keys[i]; var value = Object.getOwnPropertyDescriptor(defaults, key); if (value && value.configurable && obj[key] === undefined) { Object.defineProperty(obj, key, value); } } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : _defaults(subClass, superClass); }

var DropdownMenuGroup = function (_React$Component) {
  _inherits(DropdownMenuGroup, _React$Component);

  function DropdownMenuGroup() {
    var _temp, _this, _ret;

    _classCallCheck(this, DropdownMenuGroup);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _React$Component.call.apply(_React$Component, [this].concat(args))), _this), _this.DropdownMenuGroup = null, _this.handleClickGroup = function (event) {
      var _this$props = _this.props,
          onClick = _this$props.onClick,
          classPrefix = _this$props.classPrefix;

      (0, _domLib.toggleClass)(_this.DropdownMenuGroup, classPrefix + '-closed');
      onClick && onClick(event);
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  DropdownMenuGroup.prototype.render = function render() {
    var _this2 = this;

    var _props = this.props,
        title = _props.title,
        children = _props.children,
        classPrefix = _props.classPrefix,
        className = _props.className,
        rest = _objectWithoutProperties(_props, ['title', 'children', 'classPrefix', 'className']);

    var addPrefix = (0, _utils.prefix)(classPrefix);
    var classes = (0, _classnames2.default)(classPrefix, className);
    var unhandled = (0, _utils.getUnhandledProps)(DropdownMenuGroup, rest);

    return React.createElement(
      'li',
      _extends({}, unhandled, {
        className: classes,
        ref: function ref(_ref) {
          _this2.DropdownMenuGroup = _ref;
        }
      }),
      React.createElement(
        'div',
        {
          className: addPrefix('title'),
          role: 'menuitem',
          tabIndex: -1,
          onClick: this.handleClickGroup
        },
        React.createElement(
          'span',
          null,
          title
        ),
        React.createElement('span', { className: addPrefix('caret') })
      ),
      React.createElement(
        'ul',
        { className: addPrefix('children') },
        children
      )
    );
  };

  return DropdownMenuGroup;
}(React.Component);

DropdownMenuGroup.defaultProps = {
  classPrefix: 'dropdown-menu-group'
};
DropdownMenuGroup.handledProps = ['children', 'className', 'classPrefix', 'onClick', 'title'];
DropdownMenuGroup.propTypes = {
  title: _propTypes2.default.node.isRequired,
  classPrefix: _propTypes2.default.string.isRequired,
  className: _propTypes2.default.string,
  children: _propTypes2.default.node,
  onClick: _propTypes2.default.func
};
exports.default = DropdownMenuGroup;