'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _utils = require('../utils');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _defaults(obj, defaults) { var keys = Object.getOwnPropertyNames(defaults); for (var i = 0; i < keys.length; i++) { var key = keys[i]; var value = Object.getOwnPropertyDescriptor(defaults, key); if (value && value.configurable && obj[key] === undefined) { Object.defineProperty(obj, key, value); } } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : _defaults(subClass, superClass); }

var PickerToggle = function (_React$Component) {
  _inherits(PickerToggle, _React$Component);

  function PickerToggle() {
    var _temp, _this, _ret;

    _classCallCheck(this, PickerToggle);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _React$Component.call.apply(_React$Component, [this].concat(args))), _this), _this.addPrefix = function (name) {
      return (0, _utils.prefix)(_this.props.classPrefix)(name);
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  PickerToggle.prototype.renderToggleClean = function renderToggleClean() {
    var onClean = this.props.onClean;

    return React.createElement(
      'span',
      {
        className: this.addPrefix('clean'),
        role: 'button',
        tabIndex: '-1',
        onClick: function onClick(e) {
          onClean && onClean(e);
          e.stopPropagation();
        }
      },
      '\u2715'
    );
  };

  PickerToggle.prototype.render = function render() {
    var _props = this.props,
        Component = _props.componentClass,
        children = _props.children,
        className = _props.className,
        hasValue = _props.hasValue,
        cleanable = _props.cleanable,
        classPrefix = _props.classPrefix,
        caret = _props.caret,
        rest = _objectWithoutProperties(_props, ['componentClass', 'children', 'className', 'hasValue', 'cleanable', 'classPrefix', 'caret']);

    var defaultClassName = Component === 'a' ? classPrefix : this.addPrefix('custom');
    var classes = (0, _classnames2.default)(defaultClassName, className);
    var unhandled = (0, _utils.getUnhandledProps)(PickerToggle, rest);

    return React.createElement(
      Component,
      _extends({}, unhandled, { role: 'button', tabIndex: '-1', className: classes }),
      hasValue ? React.createElement(
        'span',
        { className: this.addPrefix('value') },
        children
      ) : React.createElement(
        'span',
        { className: this.addPrefix('placeholder') },
        children
      ),
      hasValue && cleanable && this.renderToggleClean(),
      caret && React.createElement('span', { className: this.addPrefix('caret') })
    );
  };

  return PickerToggle;
}(React.Component);

PickerToggle.defaultProps = {
  componentClass: 'a',
  caret: true
};
PickerToggle.handledProps = ['caret', 'children', 'className', 'classPrefix', 'cleanable', 'componentClass', 'hasValue', 'onClean'];
PickerToggle.propTypes = {
  classPrefix: _propTypes2.default.string,
  hasValue: _propTypes2.default.bool,
  cleanable: _propTypes2.default.bool,
  className: _propTypes2.default.string,
  children: _propTypes2.default.node,
  caret: _propTypes2.default.bool,
  componentClass: function componentClass() {
    return (typeof (React.ElementType == null ? {} : React.ElementType) === 'function' ? _propTypes2.default.instanceOf(React.ElementType == null ? {} : React.ElementType).isRequired : _propTypes2.default.any.isRequired).apply(this, arguments);
  },
  onClean: _propTypes2.default.func
};


var enhance = (0, _utils.defaultProps)({
  classPrefix: 'picker-toggle'
});

exports.default = enhance(PickerToggle);